import * as React from 'react';
import type { TLShape, TLShapeUtil } from '+types';
export declare const ShapeUtil: new <T extends TLShape, E extends Element, M = any, K = unknown>(fn: (this: TLShapeUtil<T, E, M, {
    [key: string]: any;
}>) => Partial<TLShapeUtil<T, E, M, {
    [key: string]: any;
}>> & Pick<TLShapeUtil<T, E, M, {
    [key: string]: any;
}>, "type" | "defaultProps" | "Component" | "Indicator" | "getBounds"> & K) => {
    [key: string]: any;
} & {
    type: T["type"];
    defaultProps: T;
    Component(this: TLShapeUtil<T, E, M, {
        [key: string]: any;
    }>, props: import("+types").TLRenderInfo<T, E, M>, ref: ((instance: E | null) => void) | React.MutableRefObject<E | null> | null): React.ReactElement<import("+types").TLRenderInfo<T, E, M>, E["tagName"]>;
    Indicator(this: TLShapeUtil<T, E, M, {
        [key: string]: any;
    }>, props: {
        shape: T;
        meta: M;
        isHovered: boolean;
        isSelected: boolean;
    }): React.ReactElement<any, string | React.JSXElementConstructor<any>> | null;
    getBounds(this: TLShapeUtil<T, E, M, {
        [key: string]: any;
    }>, shape: T): import("+types").TLBounds;
    refMap: Map<string, React.RefObject<E>>;
    boundsCache: WeakMap<TLShape, import("+types").TLBounds>;
    isAspectRatioLocked: boolean;
    canEdit: boolean;
    canClone: boolean;
    canBind: boolean;
    isStateful: boolean;
    showBounds: boolean;
    getRotatedBounds(this: TLShapeUtil<T, E, M, {
        [key: string]: any;
    }>, shape: T): import("+types").TLBounds;
    hitTest(this: TLShapeUtil<T, E, M, {
        [key: string]: any;
    }>, shape: T, point: number[]): boolean;
    hitTestBounds(this: TLShapeUtil<T, E, M, {
        [key: string]: any;
    }>, shape: T, bounds: import("+types").TLBounds): boolean;
    shouldRender(this: TLShapeUtil<T, E, M, {
        [key: string]: any;
    }>, prev: T, next: T): boolean;
    getCenter(this: TLShapeUtil<T, E, M, {
        [key: string]: any;
    }>, shape: T): number[];
    getRef(this: TLShapeUtil<T, E, M, {
        [key: string]: any;
    }>, shape: T): React.RefObject<E>;
    getBindingPoint<K_1 extends TLShape>(this: TLShapeUtil<T, E, M, {
        [key: string]: any;
    }>, shape: T, fromShape: K_1, point: number[], origin: number[], direction: number[], padding: number, bindAnywhere: boolean): {
        point: number[];
        distance: number;
    } | undefined;
    create: (this: TLShapeUtil<T, E, M, {
        [key: string]: any;
    }>, props: {
        id: string;
    } & Partial<T>) => T;
    mutate: (this: TLShapeUtil<T, E, M, {
        [key: string]: any;
    }>, shape: T, props: Partial<T>) => Partial<T>;
    transform: (this: TLShapeUtil<T, E, M, {
        [key: string]: any;
    }>, shape: T, bounds: import("+types").TLBounds, info: import("+types").TLTransformInfo<T>) => void | Partial<T>;
    transformSingle: (this: TLShapeUtil<T, E, M, {
        [key: string]: any;
    }>, shape: T, bounds: import("+types").TLBounds, info: import("+types").TLTransformInfo<T>) => void | Partial<T>;
    updateChildren: <K_2 extends TLShape>(this: TLShapeUtil<T, E, M, {
        [key: string]: any;
    }>, shape: T, children: K_2[]) => void | Partial<K_2>[];
    onChildrenChange: (this: TLShapeUtil<T, E, M, {
        [key: string]: any;
    }>, shape: T, children: TLShape[]) => void | Partial<T>;
    onBindingChange: (this: TLShapeUtil<T, E, M, {
        [key: string]: any;
    }>, shape: T, binding: import("+types").TLBinding<any>, target: TLShape, targetBounds: import("+types").TLBounds, center: number[]) => void | Partial<T>;
    onHandleChange: (this: TLShapeUtil<T, E, M, {
        [key: string]: any;
    }>, shape: T, handle: Partial<T["handles"]>, info: Partial<import("+types").TLPointerInfo<string>>) => void | Partial<T>;
    onRightPointHandle: (this: TLShapeUtil<T, E, M, {
        [key: string]: any;
    }>, shape: T, handle: Partial<T["handles"]>, info: Partial<import("+types").TLPointerInfo<string>>) => void | Partial<T>;
    onDoubleClickHandle: (this: TLShapeUtil<T, E, M, {
        [key: string]: any;
    }>, shape: T, handle: Partial<T["handles"]>, info: Partial<import("+types").TLPointerInfo<string>>) => void | Partial<T>;
    onDoubleClickBoundsHandle: (this: TLShapeUtil<T, E, M, {
        [key: string]: any;
    }>, shape: T) => void | Partial<T>;
    onSessionComplete: (this: TLShapeUtil<T, E, M, {
        [key: string]: any;
    }>, shape: T) => void | Partial<T>;
    onStyleChange: (this: TLShapeUtil<T, E, M, {
        [key: string]: any;
    }>, shape: T) => void | Partial<T>;
    _Component: React.ForwardRefExoticComponent<any>;
} & Partial<TLShapeUtil<T, E, M, {
    [key: string]: any;
}>> & Pick<TLShapeUtil<T, E, M, {
    [key: string]: any;
}>, "type" | "defaultProps" | "Component" | "Indicator" | "getBounds"> & K;
//# sourceMappingURL=createShape.d.ts.map