var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b2) => {
  for (var prop in b2 || (b2 = {}))
    if (__hasOwnProp.call(b2, prop))
      __defNormalProp(a, prop, b2[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b2)) {
      if (__propIsEnum.call(b2, prop))
        __defNormalProp(a, prop, b2[prop]);
    }
  return a;
};
var __spreadProps = (a, b2) => __defProps(a, __getOwnPropDescs(b2));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};

// src/components/renderer/renderer.tsx
import {
  createElement as createElement27,
  useEffect as useEffect7,
  useRef as useRef9,
  useState
} from "react";

// src/components/canvas/canvas.tsx
import {
  createElement as createElement26,
  useRef as useRef8
} from "react";

// src/hooks/useTLContext.tsx
import {
  createContext,
  useContext
} from "react";
var TLContext = createContext({});
function useTLContext() {
  const context = useContext(TLContext);
  return context;
}

// src/hooks/useZoomEvents.ts
import {
  useEffect,
  useRef
} from "react";

// ../../node_modules/@use-gesture/core/dist/maths-b2a210f4.esm.js
function clamp(v, min, max) {
  return Math.max(min, Math.min(v, max));
}
var V = {
  toVector(v, fallback) {
    if (v === void 0)
      v = fallback;
    return Array.isArray(v) ? v : [v, v];
  },
  add(v1, v2) {
    return [v1[0] + v2[0], v1[1] + v2[1]];
  },
  sub(v1, v2) {
    return [v1[0] - v2[0], v1[1] - v2[1]];
  },
  addTo(v1, v2) {
    v1[0] += v2[0];
    v1[1] += v2[1];
  },
  subTo(v1, v2) {
    v1[0] -= v2[0];
    v1[1] -= v2[1];
  }
};
function rubberband(distance, dimension, constant) {
  if (dimension === 0 || Math.abs(dimension) === Infinity)
    return Math.pow(distance, constant * 5);
  return distance * dimension * constant / (dimension + constant * distance);
}
function rubberbandIfOutOfBounds(position, min, max, constant = 0.15) {
  if (constant === 0)
    return clamp(position, min, max);
  if (position < min)
    return -rubberband(min - position, max - min, constant) + min;
  if (position > max)
    return +rubberband(position - max, max - min, constant) + max;
  return position;
}
function computeRubberband(bounds, [Vx, Vy], [Rx, Ry]) {
  const [[X0, X1], [Y0, Y1]] = bounds;
  return [rubberbandIfOutOfBounds(Vx, X0, X1, Rx), rubberbandIfOutOfBounds(Vy, Y0, Y1, Ry)];
}

// ../../node_modules/@use-gesture/core/dist/actions-4761ff01.esm.js
function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}
function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) {
      symbols = symbols.filter(function(sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
    }
    keys.push.apply(keys, symbols);
  }
  return keys;
}
function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    if (i % 2) {
      ownKeys(Object(source), true).forEach(function(key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function(key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }
  return target;
}
var EVENT_TYPE_MAP = {
  pointer: {
    start: "down",
    change: "move",
    end: "up"
  },
  mouse: {
    start: "down",
    change: "move",
    end: "up"
  },
  touch: {
    start: "start",
    change: "move",
    end: "end"
  },
  gesture: {
    start: "start",
    change: "change",
    end: "end"
  }
};
function capitalize(string) {
  if (!string)
    return "";
  return string[0].toUpperCase() + string.slice(1);
}
function toHandlerProp(device, action = "", capture = false) {
  const deviceProps = EVENT_TYPE_MAP[device];
  const actionKey = deviceProps ? deviceProps[action] || action : action;
  return "on" + capitalize(device) + capitalize(actionKey) + (capture ? "Capture" : "");
}
function toDomEventType(device, action = "") {
  const deviceProps = EVENT_TYPE_MAP[device];
  const actionKey = deviceProps ? deviceProps[action] || action : action;
  return device + actionKey;
}
function isTouch(event) {
  return "touches" in event;
}
function getCurrentTargetTouchList(event) {
  return Array.from(event.touches).filter((e2) => {
    var _event$currentTarget, _event$currentTarget$;
    return e2.target === event.currentTarget || ((_event$currentTarget = event.currentTarget) === null || _event$currentTarget === void 0 ? void 0 : (_event$currentTarget$ = _event$currentTarget.contains) === null || _event$currentTarget$ === void 0 ? void 0 : _event$currentTarget$.call(_event$currentTarget, e2.target));
  });
}
function getTouchList(event) {
  return event.type === "touchend" ? event.changedTouches : event.targetTouches;
}
function getValueEvent(event) {
  return isTouch(event) ? getTouchList(event)[0] : event;
}
function distanceAngle(P1, P2) {
  const dx = P2.clientX - P1.clientX;
  const dy = P2.clientY - P1.clientY;
  const cx = (P2.clientX + P1.clientX) / 2;
  const cy = (P2.clientY + P1.clientY) / 2;
  const distance = Math.hypot(dx, dy);
  const angle = -(Math.atan2(dx, dy) * 180) / Math.PI;
  const origin = [cx, cy];
  return {
    angle,
    distance,
    origin
  };
}
function touchIds(event) {
  return getCurrentTargetTouchList(event).map((touch) => touch.identifier);
}
function touchDistanceAngle(event, ids) {
  const [P1, P2] = Array.from(event.touches).filter((touch) => ids.includes(touch.identifier));
  return distanceAngle(P1, P2);
}
function pointerId(event) {
  const valueEvent = getValueEvent(event);
  return isTouch(event) ? valueEvent.identifier : valueEvent.pointerId;
}
function pointerValues(event) {
  const valueEvent = getValueEvent(event);
  return [valueEvent.clientX, valueEvent.clientY];
}
var LINE_HEIGHT = 40;
var PAGE_HEIGHT = 800;
function wheelValues(event) {
  let {
    deltaX,
    deltaY,
    deltaMode
  } = event;
  if (deltaMode === 1) {
    deltaX *= LINE_HEIGHT;
    deltaY *= LINE_HEIGHT;
  } else if (deltaMode === 2) {
    deltaX *= PAGE_HEIGHT;
    deltaY *= PAGE_HEIGHT;
  }
  return [deltaX, deltaY];
}
function scrollValues(event) {
  var _ref, _ref2;
  const {
    scrollX,
    scrollY,
    scrollLeft,
    scrollTop
  } = event.currentTarget;
  return [(_ref = scrollX !== null && scrollX !== void 0 ? scrollX : scrollLeft) !== null && _ref !== void 0 ? _ref : 0, (_ref2 = scrollY !== null && scrollY !== void 0 ? scrollY : scrollTop) !== null && _ref2 !== void 0 ? _ref2 : 0];
}
function getEventDetails(event) {
  const payload = {};
  if ("buttons" in event)
    payload.buttons = event.buttons;
  if ("shiftKey" in event) {
    const {
      shiftKey,
      altKey,
      metaKey,
      ctrlKey
    } = event;
    Object.assign(payload, {
      shiftKey,
      altKey,
      metaKey,
      ctrlKey
    });
  }
  return payload;
}
function call(v, ...args) {
  if (typeof v === "function") {
    return v(...args);
  } else {
    return v;
  }
}
function noop() {
}
function chain(...fns) {
  if (fns.length === 0)
    return noop;
  if (fns.length === 1)
    return fns[0];
  return function() {
    let result;
    for (const fn of fns) {
      result = fn.apply(this, arguments) || result;
    }
    return result;
  };
}
function assignDefault(value, fallback) {
  return Object.assign({}, fallback, value || {});
}
var BEFORE_LAST_KINEMATICS_DELAY = 32;
var Engine = class {
  constructor(ctrl, args, key) {
    this.ctrl = ctrl;
    this.args = args;
    this.key = key;
    if (!this.state) {
      this.state = {
        values: [0, 0],
        initial: [0, 0]
      };
      if (this.init)
        this.init();
      this.reset();
    }
  }
  get state() {
    return this.ctrl.state[this.key];
  }
  set state(state) {
    this.ctrl.state[this.key] = state;
  }
  get shared() {
    return this.ctrl.state.shared;
  }
  get eventStore() {
    return this.ctrl.gestureEventStores[this.key];
  }
  get timeoutStore() {
    return this.ctrl.gestureTimeoutStores[this.key];
  }
  get config() {
    return this.ctrl.config[this.key];
  }
  get sharedConfig() {
    return this.ctrl.config.shared;
  }
  get handler() {
    return this.ctrl.handlers[this.key];
  }
  reset() {
    const {
      state,
      shared,
      config,
      ingKey,
      args
    } = this;
    const {
      transform,
      threshold = [0, 0]
    } = config;
    shared[ingKey] = state._active = state.active = state._blocked = state._force = false;
    state._step = [false, false];
    state.intentional = false;
    state._movement = [0, 0];
    state._distance = [0, 0];
    state._delta = [0, 0];
    state._threshold = V.sub(transform(threshold), transform([0, 0])).map(Math.abs);
    state._bounds = [[-Infinity, Infinity], [-Infinity, Infinity]];
    state.args = args;
    state.axis = void 0;
    state.memo = void 0;
    state.elapsedTime = 0;
    state.direction = [0, 0];
    state.distance = [0, 0];
    state.velocity = [0, 0];
    state.movement = [0, 0];
    state.delta = [0, 0];
    state.timeStamp = 0;
  }
  start(event) {
    const state = this.state;
    const config = this.config;
    if (!state._active) {
      this.reset();
      state._active = true;
      state.target = event.target;
      state.currentTarget = event.currentTarget;
      state.initial = state.values;
      state.lastOffset = config.from ? call(config.from, state) : state.offset;
      state.offset = state.lastOffset;
    }
    state.startTime = state.timeStamp = event.timeStamp;
  }
  compute(event) {
    const {
      state,
      config,
      shared
    } = this;
    state.args = this.args;
    let dt = 0;
    if (event) {
      state.event = event;
      if (config.preventDefault && event.cancelable)
        state.event.preventDefault();
      state.type = event.type;
      shared.touches = this.ctrl.pointerIds.size || this.ctrl.touchIds.size;
      shared.locked = !!document.pointerLockElement;
      Object.assign(shared, getEventDetails(event));
      shared.down = shared.pressed = shared.buttons % 2 === 1 || shared.touches > 0;
      dt = event.timeStamp - state.timeStamp;
      state.timeStamp = event.timeStamp;
      state.elapsedTime = state.timeStamp - state.startTime;
    }
    if (state._active) {
      const _absoluteDelta = state._delta.map(Math.abs);
      V.addTo(state._distance, _absoluteDelta);
    }
    const [_m0, _m1] = config.transform(state._movement);
    const [_t0, _t1] = state._threshold;
    let [_s0, _s1] = state._step;
    if (_s0 === false)
      _s0 = Math.abs(_m0) >= _t0 && Math.sign(_m0) * _t0;
    if (_s1 === false)
      _s1 = Math.abs(_m1) >= _t1 && Math.sign(_m1) * _t1;
    state.intentional = _s0 !== false || _s1 !== false;
    if (!state.intentional)
      return;
    state._step = [_s0, _s1];
    const movement = [0, 0];
    movement[0] = _s0 !== false ? _m0 - _s0 : 0;
    movement[1] = _s1 !== false ? _m1 - _s1 : 0;
    if (this.intent)
      this.intent(movement);
    if (state._active && !state._blocked || state.active) {
      state.first = state._active && !state.active;
      state.last = !state._active && state.active;
      state.active = shared[this.ingKey] = state._active;
      if (event) {
        if (state.first) {
          if ("bounds" in config)
            state._bounds = call(config.bounds, state);
          if (this.setup)
            this.setup();
        }
        state.movement = movement;
        const previousOffset = state.offset;
        this.computeOffset();
        if (!state.last || dt > BEFORE_LAST_KINEMATICS_DELAY) {
          state.delta = V.sub(state.offset, previousOffset);
          const absoluteDelta = state.delta.map(Math.abs);
          V.addTo(state.distance, absoluteDelta);
          state.direction = state.delta.map(Math.sign);
          if (!state.first && dt > 0) {
            state.velocity = [absoluteDelta[0] / dt, absoluteDelta[1] / dt];
          }
        }
      }
    }
    const rubberband2 = state._active ? config.rubberband || [0, 0] : [0, 0];
    state.offset = computeRubberband(state._bounds, state.offset, rubberband2);
    this.computeMovement();
  }
  emit() {
    const state = this.state;
    const shared = this.shared;
    const config = this.config;
    if (!state._active)
      this.clean();
    if ((state._blocked || !state.intentional) && !state._force && !config.triggerAllEvents)
      return;
    const memo19 = this.handler(_objectSpread2(_objectSpread2(_objectSpread2({}, shared), state), {}, {
      [this.aliasKey]: state.values
    }));
    if (memo19 !== void 0)
      state.memo = memo19;
  }
  clean() {
    this.eventStore.clean();
    this.timeoutStore.clean();
  }
};
function selectAxis([dx, dy]) {
  const d = Math.abs(dx) - Math.abs(dy);
  if (d > 0)
    return "x";
  if (d < 0)
    return "y";
  return void 0;
}
function restrictVectorToAxis(v, axis) {
  switch (axis) {
    case "x":
      v[1] = 0;
      break;
    case "y":
      v[0] = 0;
      break;
  }
}
var CoordinatesEngine = class extends Engine {
  constructor(...args) {
    super(...args);
    _defineProperty(this, "aliasKey", "xy");
  }
  reset() {
    super.reset();
    this.state.axis = void 0;
  }
  init() {
    this.state.offset = [0, 0];
    this.state.lastOffset = [0, 0];
  }
  computeOffset() {
    this.state.offset = V.add(this.state.lastOffset, this.state.movement);
  }
  computeMovement() {
    this.state.movement = V.sub(this.state.offset, this.state.lastOffset);
  }
  intent(v) {
    this.state.axis = this.state.axis || selectAxis(v);
    this.state._blocked = (this.config.lockDirection || !!this.config.axis) && !this.state.axis || !!this.config.axis && this.config.axis !== this.state.axis;
    if (this.state._blocked)
      return;
    if (this.config.axis || this.config.lockDirection) {
      restrictVectorToAxis(v, this.state.axis);
    }
  }
};
var DEFAULT_RUBBERBAND = 0.15;
var commonConfigResolver = {
  enabled(value = true) {
    return value;
  },
  preventDefault(value = false) {
    return value;
  },
  triggerAllEvents(value = false) {
    return value;
  },
  rubberband(value = 0) {
    switch (value) {
      case true:
        return [DEFAULT_RUBBERBAND, DEFAULT_RUBBERBAND];
      case false:
        return [0, 0];
      default:
        return V.toVector(value);
    }
  },
  from(value) {
    if (typeof value === "function")
      return value;
    if (value != null)
      return V.toVector(value);
  },
  transform(value, _k, config) {
    return value || config.shared.transform;
  }
};
if (true) {
  Object.assign(commonConfigResolver, {
    domTarget(value) {
      if (value !== void 0) {
        throw Error(`[@use-gesture]: \`domTarget\` option has been renamed to \`target\`.`);
      }
    },
    lockDirection(value) {
      if (value !== void 0) {
        throw Error(`[@use-gesture]: \`lockDirection\` option has been merged with \`axis\`. Use it as in \`{ axis: 'lock' }\``);
      }
    },
    initial(value) {
      if (value !== void 0) {
        throw Error(`[@use-gesture]: \`initial\` option has been renamed to \`from\`.`);
      }
    }
  });
}
var coordinatesConfigResolver = _objectSpread2(_objectSpread2({}, commonConfigResolver), {}, {
  axis(_v, _k, {
    axis
  }) {
    this.lockDirection = axis === "lock";
    if (!this.lockDirection)
      return axis;
  },
  bounds(value = {}) {
    if (typeof value === "function") {
      return (state) => coordinatesConfigResolver.bounds(value(state));
    }
    if ("current" in value) {
      return () => value.current;
    }
    if (typeof HTMLElement === "function" && value instanceof HTMLElement) {
      return value;
    }
    const {
      left = -Infinity,
      right = Infinity,
      top = -Infinity,
      bottom = Infinity
    } = value;
    return [[left, right], [top, bottom]];
  }
});
var DISPLACEMENT = 10;
var KEYS_DELTA_MAP = {
  ArrowRight: (factor = 1) => [DISPLACEMENT * factor, 0],
  ArrowLeft: (factor = 1) => [-DISPLACEMENT * factor, 0],
  ArrowUp: (factor = 1) => [0, -DISPLACEMENT * factor],
  ArrowDown: (factor = 1) => [0, DISPLACEMENT * factor]
};
var DragEngine = class extends CoordinatesEngine {
  constructor(...args) {
    super(...args);
    _defineProperty(this, "ingKey", "dragging");
  }
  reset() {
    super.reset();
    const state = this.state;
    state._pointerId = void 0;
    state._pointerActive = false;
    state._keyboardActive = false;
    state._preventScroll = false;
    state._delayed = false;
    state.swipe = [0, 0];
    state.tap = false;
    state.canceled = false;
    state.cancel = this.cancel.bind(this);
  }
  setup() {
    const state = this.state;
    if (state._bounds instanceof HTMLElement) {
      const boundRect = state._bounds.getBoundingClientRect();
      const targetRect = state.currentTarget.getBoundingClientRect();
      const _bounds = {
        left: boundRect.left - targetRect.left + state.offset[0],
        right: boundRect.right - targetRect.right + state.offset[0],
        top: boundRect.top - targetRect.top + state.offset[1],
        bottom: boundRect.bottom - targetRect.bottom + state.offset[1]
      };
      state._bounds = coordinatesConfigResolver.bounds(_bounds);
    }
  }
  cancel() {
    const state = this.state;
    if (state.canceled)
      return;
    setTimeout(() => {
      state.canceled = true;
      state._active = false;
      this.compute();
      this.emit();
    }, 0);
  }
  setActive() {
    this.state._active = this.state._pointerActive || this.state._keyboardActive;
  }
  clean() {
    this.pointerClean();
    this.state._pointerActive = false;
    this.state._keyboardActive = false;
    super.clean();
  }
  pointerDown(event) {
    if (event.buttons != null && event.buttons % 2 !== 1)
      return;
    this.ctrl.setEventIds(event);
    if (this.config.pointerCapture) {
      event.target.setPointerCapture(event.pointerId);
    }
    const state = this.state;
    const config = this.config;
    if (state._pointerActive)
      return;
    this.start(event);
    this.setupPointer(event);
    state._pointerId = pointerId(event);
    state._pointerActive = true;
    state.values = pointerValues(event);
    state.initial = state.values;
    if (config.preventScroll) {
      this.setupScrollPrevention(event);
    } else if (config.delay > 0) {
      this.setupDelayTrigger(event);
    } else {
      this.startPointerDrag(event);
    }
  }
  startPointerDrag(event) {
    const state = this.state;
    state._active = true;
    state._preventScroll = true;
    state._delayed = false;
    this.compute(event);
    this.emit();
  }
  pointerMove(event) {
    const state = this.state;
    const config = this.config;
    if (!state._pointerActive)
      return;
    if (state.type === event.type && event.timeStamp === state.timeStamp)
      return;
    const id = pointerId(event);
    if (state._pointerId && id !== state._pointerId)
      return;
    const values = pointerValues(event);
    if (document.pointerLockElement === event.target) {
      state._delta = [event.movementX, event.movementY];
    } else {
      state._delta = V.sub(values, state.values);
      state.values = values;
    }
    V.addTo(state._movement, state._delta);
    this.compute(event);
    if (state._delayed) {
      this.timeoutStore.remove("dragDelay");
      state.active = false;
      this.startPointerDrag(event);
      return;
    }
    if (config.preventScroll && !state._preventScroll) {
      if (state.axis) {
        if (state.axis === config.preventScrollAxis || config.preventScrollAxis === "xy") {
          state._active = false;
          this.clean();
          return;
        } else {
          this.timeoutStore.remove("startPointerDrag");
          this.startPointerDrag(event);
          return;
        }
      } else {
        return;
      }
    }
    this.emit();
  }
  pointerUp(event) {
    this.ctrl.setEventIds(event);
    try {
      if (this.config.pointerCapture && event.target.hasPointerCapture(event.pointerId)) {
        ;
        event.target.releasePointerCapture(event.pointerId);
      }
    } catch (_unused) {
      if (true) {
        console.warn(`[@use-gesture]: If you see this message, it's likely that you're using an outdated version of \`@react-three/fiber\`. 

Please upgrade to the latest version.`);
      }
    }
    const state = this.state;
    const config = this.config;
    if (!state._pointerActive)
      return;
    const id = pointerId(event);
    if (state._pointerId && id !== state._pointerId)
      return;
    this.state._pointerActive = false;
    this.setActive();
    this.compute(event);
    const [dx, dy] = state._distance;
    state.tap = dx <= 3 && dy <= 3;
    if (state.tap && config.filterTaps) {
      state._force = true;
    } else {
      const [dirx, diry] = state.direction;
      const [vx, vy] = state.velocity;
      const [mx, my] = state.movement;
      const [svx, svy] = config.swipe.velocity;
      const [sx, sy] = config.swipe.distance;
      const sdt = config.swipe.duration;
      if (state.elapsedTime < sdt) {
        if (Math.abs(vx) > svx && Math.abs(mx) > sx)
          state.swipe[0] = dirx;
        if (Math.abs(vy) > svy && Math.abs(my) > sy)
          state.swipe[1] = diry;
      }
    }
    this.emit();
  }
  pointerClick(event) {
    if (!this.state.tap) {
      event.preventDefault();
      event.stopPropagation();
    }
  }
  setupPointer(event) {
    const config = this.config;
    let device = config.device;
    if (true) {
      try {
        if (device === "pointer") {
          const currentTarget = "uv" in event ? event.sourceEvent.currentTarget : event.currentTarget;
          const style = window.getComputedStyle(currentTarget);
          if (style.touchAction === "auto") {
            console.warn(`[@use-gesture]: The drag target has its \`touch-action\` style property set to \`auto\`. It is recommended to add \`touch-action: 'none'\` so that the drag gesture behaves correctly on touch-enabled devices. For more information read this: https://use-gesture.netlify.app/docs/extras/#touch-action.

This message will only show in development mode. It won't appear in production. If this is intended, you can ignore it.`, currentTarget);
          }
        }
      } catch (_unused2) {
      }
    }
    if (config.pointerLock) {
      event.currentTarget.requestPointerLock();
    }
    if (!config.pointerCapture) {
      this.eventStore.add(this.sharedConfig.window, device, "change", this.pointerMove.bind(this));
      this.eventStore.add(this.sharedConfig.window, device, "end", this.pointerUp.bind(this));
    }
  }
  pointerClean() {
    if (this.config.pointerLock && document.pointerLockElement === this.state.currentTarget) {
      document.exitPointerLock();
    }
  }
  preventScroll(event) {
    if (this.state._preventScroll && event.cancelable) {
      event.preventDefault();
    }
  }
  setupScrollPrevention(event) {
    persistEvent(event);
    this.eventStore.add(this.sharedConfig.window, "touch", "change", this.preventScroll.bind(this), {
      passive: false
    });
    this.eventStore.add(this.sharedConfig.window, "touch", "end", this.clean.bind(this), {
      passive: false
    });
    this.eventStore.add(this.sharedConfig.window, "touch", "cancel", this.clean.bind(this), {
      passive: false
    });
    this.timeoutStore.add("startPointerDrag", this.startPointerDrag.bind(this), this.config.preventScroll, event);
  }
  setupDelayTrigger(event) {
    this.state._delayed = true;
    this.timeoutStore.add("dragDelay", this.startPointerDrag.bind(this), this.config.delay, event);
  }
  keyDown(event) {
    const deltaFn = KEYS_DELTA_MAP[event.key];
    const state = this.state;
    if (deltaFn) {
      const factor = event.shiftKey ? 10 : event.altKey ? 0.1 : 1;
      state._delta = deltaFn(factor);
      this.start(event);
      state._keyboardActive = true;
      V.addTo(state._movement, state._delta);
      this.compute(event);
      this.emit();
    }
  }
  keyUp(event) {
    if (!(event.key in KEYS_DELTA_MAP))
      return;
    this.state._keyboardActive = false;
    this.setActive();
    this.compute(event);
    this.emit();
  }
  bind(bindFunction) {
    const device = this.config.device;
    bindFunction(device, "start", this.pointerDown.bind(this));
    if (this.config.pointerCapture) {
      bindFunction(device, "change", this.pointerMove.bind(this));
      bindFunction(device, "end", this.pointerUp.bind(this));
      bindFunction(device, "cancel", this.pointerUp.bind(this));
    }
    bindFunction("key", "down", this.keyDown.bind(this));
    bindFunction("key", "up", this.keyUp.bind(this));
    if (this.config.filterTaps) {
      bindFunction("click", "", this.pointerClick.bind(this), {
        capture: true
      });
    }
  }
};
function persistEvent(event) {
  "persist" in event && typeof event.persist === "function" && event.persist();
}
var isBrowser = typeof window !== "undefined" && window.document && window.document.createElement;
function supportsTouchEvents() {
  return isBrowser && "ontouchstart" in window;
}
function isTouchScreen() {
  return supportsTouchEvents() || isBrowser && navigator.maxTouchPoints > 1;
}
function supportsPointerEvents() {
  return isBrowser && "onpointerdown" in window;
}
function supportsPointerLock() {
  return isBrowser && "exitPointerLock" in window.document;
}
function supportsGestureEvents() {
  try {
    return "constructor" in GestureEvent;
  } catch (e2) {
    return false;
  }
}
var SUPPORT = {
  isBrowser,
  gesture: supportsGestureEvents(),
  touch: supportsTouchEvents(),
  touchscreen: isTouchScreen(),
  pointer: supportsPointerEvents(),
  pointerLock: supportsPointerLock()
};
var DEFAULT_PREVENT_SCROLL_DELAY = 250;
var DEFAULT_DRAG_DELAY = 180;
var DEFAULT_SWIPE_VELOCITY = 0.5;
var DEFAULT_SWIPE_DISTANCE = 50;
var DEFAULT_SWIPE_DURATION = 250;
var dragConfigResolver = _objectSpread2(_objectSpread2({}, coordinatesConfigResolver), {}, {
  pointerLock(_v, _k, {
    pointer: {
      lock = false,
      touch = false
    } = {}
  }) {
    this.useTouch = SUPPORT.touch && touch;
    return SUPPORT.pointerLock && lock;
  },
  device(_v, _k) {
    if (this.useTouch)
      return "touch";
    if (this.pointerLock)
      return "mouse";
    if (SUPPORT.pointer)
      return "pointer";
    if (SUPPORT.touch)
      return "touch";
    return "mouse";
  },
  preventScroll(value = false, _k, {
    preventScrollAxis = "y"
  }) {
    if (preventScrollAxis)
      this.preventScrollAxis = preventScrollAxis;
    if (!SUPPORT.touchscreen)
      return false;
    if (typeof value === "number")
      return value;
    return value ? DEFAULT_PREVENT_SCROLL_DELAY : false;
  },
  pointerCapture(_v, _k, {
    pointer: {
      capture = true
    } = {}
  }) {
    return !this.pointerLock && this.device === "pointer" && capture;
  },
  threshold(value, _k, {
    filterTaps = false,
    axis = void 0
  }) {
    const threshold = V.toVector(value, filterTaps ? 3 : axis ? 1 : 0);
    this.filterTaps = filterTaps;
    return threshold;
  },
  swipe({
    velocity = DEFAULT_SWIPE_VELOCITY,
    distance = DEFAULT_SWIPE_DISTANCE,
    duration = DEFAULT_SWIPE_DURATION
  } = {}) {
    return {
      velocity: this.transform(V.toVector(velocity)),
      distance: this.transform(V.toVector(distance)),
      duration
    };
  },
  delay(value = 0) {
    switch (value) {
      case true:
        return DEFAULT_DRAG_DELAY;
      case false:
        return 0;
      default:
        return value;
    }
  }
});
if (true) {
  Object.assign(dragConfigResolver, {
    useTouch(value) {
      if (value !== void 0) {
        throw Error(`[@use-gesture]: \`useTouch\` option has been renamed to \`pointer.touch\`. Use it as in \`{ pointer: { touch: true } }\`.`);
      }
    },
    experimental_preventWindowScrollY(value) {
      if (value !== void 0) {
        throw Error(`[@use-gesture]: \`experimental_preventWindowScrollY\` option has been renamed to \`preventScroll\`.`);
      }
    },
    swipeVelocity(value) {
      if (value !== void 0) {
        throw Error(`[@use-gesture]: \`swipeVelocity\` option has been renamed to \`swipe.velocity\`. Use it as in \`{ swipe: { velocity: 0.5 } }\`.`);
      }
    },
    swipeDistance(value) {
      if (value !== void 0) {
        throw Error(`[@use-gesture]: \`swipeDistance\` option has been renamed to \`swipe.distance\`. Use it as in \`{ swipe: { distance: 50 } }\`.`);
      }
    },
    swipeDuration(value) {
      if (value !== void 0) {
        throw Error(`[@use-gesture]: \`swipeDuration\` option has been renamed to \`swipe.duration\`. Use it as in \`{ swipe: { duration: 250 } }\`.`);
      }
    }
  });
}
var SCALE_ANGLE_RATIO_INTENT_DEG = 30;
var PINCH_WHEEL_RATIO = 36;
var PinchEngine = class extends Engine {
  constructor(...args) {
    super(...args);
    _defineProperty(this, "ingKey", "pinching");
    _defineProperty(this, "aliasKey", "da");
  }
  init() {
    this.state.offset = [1, 0];
    this.state.lastOffset = [1, 0];
    this.state._pointerEvents = new Map();
  }
  reset() {
    super.reset();
    const state = this.state;
    state._touchIds = [];
    state.canceled = false;
    state.cancel = this.cancel.bind(this);
    state.turns = 0;
  }
  computeOffset() {
    const {
      type,
      movement,
      lastOffset
    } = this.state;
    if (type === "wheel") {
      this.state.offset = V.add(movement, lastOffset);
    } else {
      this.state.offset = [(1 + movement[0]) * lastOffset[0], movement[1] + lastOffset[1]];
    }
  }
  computeMovement() {
    const {
      offset,
      lastOffset
    } = this.state;
    this.state.movement = [offset[0] / lastOffset[0], offset[1] - lastOffset[1]];
  }
  intent(v) {
    const state = this.state;
    if (!state.axis) {
      const axisMovementDifference = Math.abs(v[0]) * SCALE_ANGLE_RATIO_INTENT_DEG - Math.abs(v[1]);
      if (axisMovementDifference < 0)
        state.axis = "angle";
      else if (axisMovementDifference > 0)
        state.axis = "scale";
    }
    if (this.config.lockDirection) {
      if (state.axis === "scale")
        v[1] = 0;
      else if (state.axis === "angle")
        v[0] = 0;
    }
  }
  cancel() {
    const state = this.state;
    if (state.canceled)
      return;
    setTimeout(() => {
      state.canceled = true;
      state._active = false;
      this.compute();
      this.emit();
    }, 0);
  }
  touchStart(event) {
    this.ctrl.setEventIds(event);
    const state = this.state;
    const ctrlTouchIds = this.ctrl.touchIds;
    if (state._active) {
      if (state._touchIds.every((id) => ctrlTouchIds.has(id)))
        return;
    }
    if (ctrlTouchIds.size < 2)
      return;
    this.start(event);
    state._touchIds = Array.from(ctrlTouchIds).slice(0, 2);
    const payload = touchDistanceAngle(event, state._touchIds);
    this.pinchStart(event, payload);
  }
  pointerStart(event) {
    if (event.buttons != null && event.buttons % 2 !== 1)
      return;
    this.ctrl.setEventIds(event);
    event.target.setPointerCapture(event.pointerId);
    const state = this.state;
    const _pointerEvents = state._pointerEvents;
    const ctrlPointerIds = this.ctrl.pointerIds;
    if (state._active) {
      if (Array.from(_pointerEvents.keys()).every((id) => ctrlPointerIds.has(id)))
        return;
    }
    if (_pointerEvents.size < 2) {
      _pointerEvents.set(event.pointerId, event);
    }
    if (state._pointerEvents.size < 2)
      return;
    this.start(event);
    const payload = distanceAngle(...Array.from(_pointerEvents.values()));
    this.pinchStart(event, payload);
  }
  pinchStart(event, payload) {
    const state = this.state;
    state.origin = payload.origin;
    state.values = [payload.distance, payload.angle];
    state.initial = state.values;
    this.compute(event);
    this.emit();
  }
  touchMove(event) {
    if (!this.state._active)
      return;
    const payload = touchDistanceAngle(event, this.state._touchIds);
    this.pinchMove(event, payload);
  }
  pointerMove(event) {
    const _pointerEvents = this.state._pointerEvents;
    if (_pointerEvents.has(event.pointerId)) {
      _pointerEvents.set(event.pointerId, event);
    }
    if (!this.state._active)
      return;
    const payload = distanceAngle(...Array.from(_pointerEvents.values()));
    this.pinchMove(event, payload);
  }
  pinchMove(event, payload) {
    const state = this.state;
    const prev_a = state.values[1];
    const delta_a = payload.angle - prev_a;
    let delta_turns = 0;
    if (Math.abs(delta_a) > 270)
      delta_turns += Math.sign(delta_a);
    state.values = [payload.distance, payload.angle - 360 * delta_turns];
    state.origin = payload.origin;
    state.turns = delta_turns;
    state._movement = [state.values[0] / state.initial[0] - 1, state.values[1] - state.initial[1]];
    this.compute(event);
    this.emit();
  }
  touchEnd(event) {
    this.ctrl.setEventIds(event);
    if (!this.state._active)
      return;
    if (this.state._touchIds.some((id) => !this.ctrl.touchIds.has(id))) {
      this.state._active = false;
      this.compute(event);
      this.emit();
    }
  }
  pointerEnd(event) {
    const state = this.state;
    this.ctrl.setEventIds(event);
    try {
      event.target.releasePointerCapture(event.pointerId);
    } catch (_unused) {
    }
    if (state._pointerEvents.has(event.pointerId)) {
      state._pointerEvents.delete(event.pointerId);
    }
    if (!state._active)
      return;
    if (state._pointerEvents.size < 2) {
      state._active = false;
      this.compute(event);
      this.emit();
    }
  }
  gestureStart(event) {
    if (event.cancelable)
      event.preventDefault();
    const state = this.state;
    if (state._active)
      return;
    this.start(event);
    state.values = [event.scale, event.rotation];
    state.origin = [event.clientX, event.clientY];
    this.compute(event);
    this.emit();
  }
  gestureMove(event) {
    if (event.cancelable)
      event.preventDefault();
    if (!this.state._active)
      return;
    const state = this.state;
    state.values = [event.scale, event.rotation];
    state.origin = [event.clientX, event.clientY];
    const _previousMovement = state._movement;
    state._movement = [event.scale - 1, event.rotation];
    state._delta = V.sub(state._movement, _previousMovement);
    this.compute(event);
    this.emit();
  }
  gestureEnd(event) {
    if (!this.state._active)
      return;
    this.state._active = false;
    this.compute(event);
    this.emit();
  }
  wheel(event) {
    if (!event.ctrlKey)
      return;
    if (!this.state._active)
      this.wheelStart(event);
    else
      this.wheelChange(event);
    this.timeoutStore.add("wheelEnd", this.wheelEnd.bind(this));
  }
  wheelStart(event) {
    this.start(event);
    this.wheelChange(event);
  }
  wheelChange(event) {
    const isR3f = "uv" in event;
    if (!isR3f) {
      if (event.cancelable) {
        event.preventDefault();
      }
      if (!event.defaultPrevented) {
        console.warn(`[@use-gesture]: To properly support zoom on trackpads, try using the \`target\` option.

This message will only appear in development mode.`);
      }
    }
    const state = this.state;
    state._delta = [-wheelValues(event)[1] / PINCH_WHEEL_RATIO * state.offset[0], 0];
    V.addTo(state._movement, state._delta);
    this.state.origin = [event.clientX, event.clientY];
    this.compute(event);
    this.emit();
  }
  wheelEnd() {
    if (!this.state._active)
      return;
    this.state._active = false;
    this.compute();
    this.emit();
  }
  bind(bindFunction) {
    const device = this.config.device;
    if (!!device) {
      bindFunction(device, "start", this[device + "Start"].bind(this));
      bindFunction(device, "change", this[device + "Move"].bind(this));
      bindFunction(device, "end", this[device + "End"].bind(this));
      bindFunction(device, "cancel", this[device + "End"].bind(this));
    } else {
      bindFunction("wheel", "", this.wheel.bind(this), {
        passive: false
      });
    }
  }
};
var pinchConfigResolver = _objectSpread2(_objectSpread2({}, commonConfigResolver), {}, {
  useTouch(_v, _k, {
    pointer: {
      touch = false
    } = {}
  }) {
    return SUPPORT.touch && touch;
  },
  device(_v, _k, config) {
    const sharedConfig = config.shared;
    if (sharedConfig.target && !SUPPORT.touch && SUPPORT.gesture)
      return "gesture";
    if (this.useTouch)
      return "touch";
    if (SUPPORT.touchscreen) {
      if (SUPPORT.pointer)
        return "pointer";
      if (SUPPORT.touch)
        return "touch";
    }
  },
  bounds(_v, _k, {
    scaleBounds = {},
    angleBounds = {}
  }) {
    const _scaleBounds = (state) => {
      const D = assignDefault(call(scaleBounds, state), {
        min: -Infinity,
        max: Infinity
      });
      return [D.min, D.max];
    };
    const _angleBounds = (state) => {
      const A2 = assignDefault(call(angleBounds, state), {
        min: -Infinity,
        max: Infinity
      });
      return [A2.min, A2.max];
    };
    if (typeof scaleBounds !== "function" && typeof angleBounds !== "function")
      return [_scaleBounds(), _angleBounds()];
    return (state) => [_scaleBounds(state), _angleBounds(state)];
  },
  threshold(value, _k, config) {
    this.lockDirection = config.axis === "lock";
    const threshold = V.toVector(value, this.lockDirection ? [0.1, 3] : 0);
    return threshold;
  }
});
var MoveEngine = class extends CoordinatesEngine {
  constructor(...args) {
    super(...args);
    _defineProperty(this, "ingKey", "moving");
  }
  move(event) {
    if (this.config.mouseOnly && event.pointerType !== "mouse")
      return;
    if (!this.state._active)
      this.moveStart(event);
    else
      this.moveChange(event);
    this.timeoutStore.add("moveEnd", this.moveEnd.bind(this));
  }
  moveStart(event) {
    this.start(event);
    const state = this.state;
    state.values = pointerValues(event);
    this.compute(event);
    state.initial = state.values;
    this.emit();
  }
  moveChange(event) {
    if (!this.state._active)
      return;
    const values = pointerValues(event);
    const state = this.state;
    state._delta = V.sub(values, state.values);
    V.addTo(state._movement, state._delta);
    state.values = values;
    this.compute(event);
    this.emit();
  }
  moveEnd(event) {
    if (!this.state._active)
      return;
    this.state._active = false;
    this.compute(event);
    this.emit();
  }
  bind(bindFunction) {
    bindFunction("pointer", "change", this.move.bind(this));
    bindFunction("pointer", "leave", this.moveEnd.bind(this));
  }
};
var moveConfigResolver = _objectSpread2(_objectSpread2({}, coordinatesConfigResolver), {}, {
  mouseOnly: (value = true) => value
});
var ScrollEngine = class extends CoordinatesEngine {
  constructor(...args) {
    super(...args);
    _defineProperty(this, "ingKey", "scrolling");
  }
  scroll(event) {
    if (!this.state._active)
      this.start(event);
    this.scrollChange(event);
    this.timeoutStore.add("scrollEnd", this.scrollEnd.bind(this));
  }
  scrollChange(event) {
    if (event.cancelable)
      event.preventDefault();
    const state = this.state;
    const values = scrollValues(event);
    state._delta = V.sub(values, state.values);
    V.addTo(state._movement, state._delta);
    state.values = values;
    this.compute(event);
    this.emit();
  }
  scrollEnd() {
    if (!this.state._active)
      return;
    this.state._active = false;
    this.compute();
    this.emit();
  }
  bind(bindFunction) {
    bindFunction("scroll", "", this.scroll.bind(this));
  }
};
var scrollConfigResolver = coordinatesConfigResolver;
var WheelEngine = class extends CoordinatesEngine {
  constructor(...args) {
    super(...args);
    _defineProperty(this, "ingKey", "wheeling");
  }
  wheel(event) {
    if (!this.state._active)
      this.start(event);
    this.wheelChange(event);
    this.timeoutStore.add("wheelEnd", this.wheelEnd.bind(this));
  }
  wheelChange(event) {
    const state = this.state;
    state._delta = wheelValues(event);
    V.addTo(this.state._movement, state._delta);
    this.compute(event);
    this.emit();
  }
  wheelEnd() {
    if (!this.state._active)
      return;
    this.state._active = false;
    this.compute();
    this.emit();
  }
  bind(bindFunction) {
    bindFunction("wheel", "", this.wheel.bind(this));
  }
};
var wheelConfigResolver = coordinatesConfigResolver;
var HoverEngine = class extends CoordinatesEngine {
  constructor(...args) {
    super(...args);
    _defineProperty(this, "ingKey", "hovering");
  }
  enter(event) {
    if (this.config.mouseOnly && event.pointerType !== "mouse")
      return;
    this.start(event);
    this.state.values = pointerValues(event);
    this.compute(event);
    this.emit();
  }
  leave(event) {
    if (this.config.mouseOnly && event.pointerType !== "mouse")
      return;
    const state = this.state;
    if (!state._active)
      return;
    state._active = false;
    const values = pointerValues(event);
    state._movement = state._delta = V.sub(values, state.values);
    state.values = values;
    this.compute(event);
    state.delta = state.movement;
    this.emit();
  }
  bind(bindFunction) {
    bindFunction("pointer", "enter", this.enter.bind(this));
    bindFunction("pointer", "leave", this.leave.bind(this));
  }
};
var hoverConfigResolver = _objectSpread2(_objectSpread2({}, coordinatesConfigResolver), {}, {
  mouseOnly: (value = true) => value
});
var EngineMap = new Map();
var ConfigResolverMap = new Map();
function registerAction(action) {
  EngineMap.set(action.key, action.engine);
  ConfigResolverMap.set(action.key, action.resolver);
}
var dragAction = {
  key: "drag",
  engine: DragEngine,
  resolver: dragConfigResolver
};
var hoverAction = {
  key: "hover",
  engine: HoverEngine,
  resolver: hoverConfigResolver
};
var moveAction = {
  key: "move",
  engine: MoveEngine,
  resolver: moveConfigResolver
};
var pinchAction = {
  key: "pinch",
  engine: PinchEngine,
  resolver: pinchConfigResolver
};
var scrollAction = {
  key: "scroll",
  engine: ScrollEngine,
  resolver: scrollConfigResolver
};
var wheelAction = {
  key: "wheel",
  engine: WheelEngine,
  resolver: wheelConfigResolver
};

// ../../node_modules/@use-gesture/react/dist/use-gesture-react.esm.js
import React2 from "react";

// ../../node_modules/@use-gesture/core/dist/use-gesture-core.esm.js
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null)
    return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0)
      continue;
    target[key] = source[key];
  }
  return target;
}
function _objectWithoutProperties(source, excluded) {
  if (source == null)
    return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0)
        continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key))
        continue;
      target[key] = source[key];
    }
  }
  return target;
}
var identity = (v) => v;
var sharedConfigResolver = {
  target(value) {
    if (value) {
      return () => "current" in value ? value.current : value;
    }
    return void 0;
  },
  enabled(value = true) {
    return value;
  },
  window(value = SUPPORT.isBrowser ? window : void 0) {
    return value;
  },
  eventOptions({
    passive = true,
    capture = false
  } = {}) {
    return {
      passive,
      capture
    };
  },
  transform(value = identity) {
    return value;
  }
};
var _excluded = ["target", "eventOptions", "window", "enabled", "transform"];
function resolveWith(config = {}, resolvers) {
  const result = {};
  for (const [key, resolver] of Object.entries(resolvers))
    switch (typeof resolver) {
      case "function":
        result[key] = resolver.call(result, config[key], key, config);
        break;
      case "object":
        result[key] = resolveWith(config[key], resolver);
        break;
      case "boolean":
        if (resolver)
          result[key] = config[key];
        break;
    }
  return result;
}
function parse(config, gestureKey) {
  const _ref = config, {
    target,
    eventOptions,
    window: window2,
    enabled,
    transform
  } = _ref, rest = _objectWithoutProperties(_ref, _excluded);
  const _config = {
    shared: resolveWith({
      target,
      eventOptions,
      window: window2,
      enabled,
      transform
    }, sharedConfigResolver)
  };
  if (gestureKey) {
    const resolver = ConfigResolverMap.get(gestureKey);
    _config[gestureKey] = resolveWith(_objectSpread2({
      shared: _config.shared
    }, rest), resolver);
  } else {
    for (const key in rest) {
      const resolver = ConfigResolverMap.get(key);
      if (resolver) {
        _config[key] = resolveWith(_objectSpread2({
          shared: _config.shared
        }, rest[key]), resolver);
      } else if (true) {
        if (!["drag", "pinch", "scroll", "wheel", "move", "hover"].includes(key)) {
          if (key === "domTarget") {
            throw Error(`[@use-gesture]: \`domTarget\` option has been renamed to \`target\`.`);
          }
          console.warn(`[@use-gesture]: Unknown config key \`${key}\` was used. Please read the documentation for further information.`);
        }
      }
    }
  }
  return _config;
}
var EventStore = class {
  constructor(ctrl) {
    _defineProperty(this, "_listeners", []);
    this._ctrl = ctrl;
  }
  add(element, device, action, handler, options) {
    const type = toDomEventType(device, action);
    const eventOptions = _objectSpread2(_objectSpread2({}, this._ctrl.config.shared.eventOptions), options);
    element.addEventListener(type, handler, eventOptions);
    this._listeners.push(() => element.removeEventListener(type, handler, eventOptions));
  }
  clean() {
    this._listeners.forEach((remove) => remove());
    this._listeners = [];
  }
};
var TimeoutStore = class {
  constructor() {
    _defineProperty(this, "_timeouts", new Map());
  }
  add(key, callback, ms = 140, ...args) {
    this.remove(key);
    this._timeouts.set(key, window.setTimeout(callback, ms, ...args));
  }
  remove(key) {
    const timeout = this._timeouts.get(key);
    if (timeout)
      window.clearTimeout(timeout);
  }
  clean() {
    this._timeouts.forEach((timeout) => void window.clearTimeout(timeout));
    this._timeouts.clear();
  }
};
var Controller = class {
  constructor(handlers) {
    _defineProperty(this, "gestures", new Set());
    _defineProperty(this, "_targetEventStore", new EventStore(this));
    _defineProperty(this, "gestureEventStores", {});
    _defineProperty(this, "gestureTimeoutStores", {});
    _defineProperty(this, "handlers", {});
    _defineProperty(this, "config", {});
    _defineProperty(this, "pointerIds", new Set());
    _defineProperty(this, "touchIds", new Set());
    _defineProperty(this, "state", {
      shared: {
        shiftKey: false,
        metaKey: false,
        ctrlKey: false,
        altKey: false
      }
    });
    resolveGestures(this, handlers);
  }
  setEventIds(event) {
    if (isTouch(event)) {
      this.touchIds = new Set(touchIds(event));
    } else if ("pointerId" in event) {
      if (event.type === "pointerup")
        this.pointerIds.delete(event.pointerId);
      else
        this.pointerIds.add(event.pointerId);
    }
  }
  applyHandlers(handlers, nativeHandlers) {
    this.handlers = handlers;
    this.nativeHandlers = nativeHandlers;
  }
  applyConfig(config, gestureKey) {
    this.config = parse(config, gestureKey);
  }
  clean() {
    this._targetEventStore.clean();
    for (const key of this.gestures) {
      this.gestureEventStores[key].clean();
      this.gestureTimeoutStores[key].clean();
    }
  }
  effect() {
    if (this.config.shared.target)
      this.bind();
    return () => this._targetEventStore.clean();
  }
  bind(...args) {
    const sharedConfig = this.config.shared;
    const eventOptions = sharedConfig.eventOptions;
    const props = {};
    let target;
    if (sharedConfig.target) {
      target = sharedConfig.target();
      if (!target)
        return;
    }
    const bindFunction = bindToProps(props, eventOptions, !!target);
    if (sharedConfig.enabled) {
      for (const gestureKey of this.gestures) {
        if (this.config[gestureKey].enabled) {
          const Engine2 = EngineMap.get(gestureKey);
          new Engine2(this, args, gestureKey).bind(bindFunction);
        }
      }
      for (const eventKey in this.nativeHandlers) {
        bindFunction(eventKey, "", (event) => this.nativeHandlers[eventKey](_objectSpread2(_objectSpread2({}, this.state.shared), {}, {
          event,
          args
        })), void 0, true);
      }
    }
    for (const handlerProp in props) {
      props[handlerProp] = chain(...props[handlerProp]);
    }
    if (!target)
      return props;
    for (const handlerProp in props) {
      let eventKey = handlerProp.substr(2).toLowerCase();
      const capture = !!~eventKey.indexOf("capture");
      const passive = !!~eventKey.indexOf("passive");
      if (capture || passive)
        eventKey = eventKey.replace(/capture|passive/g, "");
      this._targetEventStore.add(target, eventKey, "", props[handlerProp], {
        capture,
        passive
      });
    }
  }
};
function setupGesture(ctrl, gestureKey) {
  ctrl.gestures.add(gestureKey);
  ctrl.gestureEventStores[gestureKey] = new EventStore(ctrl);
  ctrl.gestureTimeoutStores[gestureKey] = new TimeoutStore();
}
function resolveGestures(ctrl, internalHandlers) {
  if (internalHandlers.drag)
    setupGesture(ctrl, "drag");
  if (internalHandlers.wheel)
    setupGesture(ctrl, "wheel");
  if (internalHandlers.scroll)
    setupGesture(ctrl, "scroll");
  if (internalHandlers.move)
    setupGesture(ctrl, "move");
  if (internalHandlers.pinch)
    setupGesture(ctrl, "pinch");
  if (internalHandlers.hover)
    setupGesture(ctrl, "hover");
}
var bindToProps = (props, eventOptions, withPassiveOption) => (device, action, handler, options = {}, isNative = false) => {
  var _options$capture, _options$passive;
  const capture = (_options$capture = options.capture) !== null && _options$capture !== void 0 ? _options$capture : eventOptions.capture;
  const passive = (_options$passive = options.passive) !== null && _options$passive !== void 0 ? _options$passive : eventOptions.passive;
  let handlerProp = isNative ? device : toHandlerProp(device, action, capture);
  if (withPassiveOption && passive)
    handlerProp += "Passive";
  props[handlerProp] = props[handlerProp] || [];
  props[handlerProp].push(handler);
};
var RE_NOT_NATIVE = /^on(Drag|Wheel|Scroll|Move|Pinch|Hover)/;
function sortHandlers(_handlers) {
  const native = {};
  const handlers = {};
  const actions = new Set();
  for (let key in _handlers) {
    if (RE_NOT_NATIVE.test(key)) {
      actions.add(RegExp.lastMatch);
      handlers[key] = _handlers[key];
    } else {
      native[key] = _handlers[key];
    }
  }
  return [handlers, native, actions];
}
function registerGesture(actions, handlers, handlerKey, key, internalHandlers, config) {
  if (!actions.has(handlerKey))
    return;
  if (!EngineMap.has(key)) {
    if (true) {
      console.warn(`[@use-gesture]: You've created a custom handler that that uses the \`${key}\` gesture but isn't properly configured.

Please add \`${key}Action\` when creating your handler.`);
    }
    return;
  }
  const startKey = handlerKey + "Start";
  const endKey = handlerKey + "End";
  const fn = (state) => {
    let memo19 = void 0;
    if (state.first && startKey in handlers)
      handlers[startKey](state);
    if (handlerKey in handlers)
      memo19 = handlers[handlerKey](state);
    if (state.last && endKey in handlers)
      handlers[endKey](state);
    return memo19;
  };
  internalHandlers[key] = fn;
  config[key] = config[key] || {};
}
function parseMergedHandlers(mergedHandlers, mergedConfig) {
  const [handlers, nativeHandlers, actions] = sortHandlers(mergedHandlers);
  const internalHandlers = {};
  registerGesture(actions, handlers, "onDrag", "drag", internalHandlers, mergedConfig);
  registerGesture(actions, handlers, "onWheel", "wheel", internalHandlers, mergedConfig);
  registerGesture(actions, handlers, "onScroll", "scroll", internalHandlers, mergedConfig);
  registerGesture(actions, handlers, "onPinch", "pinch", internalHandlers, mergedConfig);
  registerGesture(actions, handlers, "onMove", "move", internalHandlers, mergedConfig);
  registerGesture(actions, handlers, "onHover", "hover", internalHandlers, mergedConfig);
  return {
    handlers: internalHandlers,
    config: mergedConfig,
    nativeHandlers
  };
}

// ../../node_modules/@use-gesture/react/dist/use-gesture-react.esm.js
function useRecognizers(handlers, config = {}, gestureKey, nativeHandlers) {
  const ctrl = React2.useMemo(() => new Controller(handlers), []);
  ctrl.applyHandlers(handlers, nativeHandlers);
  ctrl.applyConfig(config, gestureKey);
  React2.useEffect(ctrl.effect.bind(ctrl));
  React2.useEffect(() => {
    return ctrl.clean.bind(ctrl);
  }, []);
  if (config.target === void 0) {
    return ctrl.bind.bind(ctrl);
  }
  return void 0;
}
function createUseGesture(actions) {
  actions.forEach(registerAction);
  return function useGesture2(_handlers, _config = {}) {
    const {
      handlers,
      nativeHandlers,
      config
    } = parseMergedHandlers(_handlers, _config);
    return useRecognizers(handlers, config, void 0, nativeHandlers);
  };
}
function useGesture(handlers, config = {}) {
  const hook = createUseGesture([dragAction, pinchAction, scrollAction, wheelAction, moveAction, hoverAction]);
  return hook(handlers, config);
}

// ../vec/dist/esm/index.js
var u = class {
  static clamp(n, r, t) {
    return Math.max(r, typeof t != "undefined" ? Math.min(n, t) : n);
  }
  static clampV(n, r, t) {
    return n.map((m) => t ? u.clamp(m, r, t) : u.clamp(m, r));
  }
  static cross(n, r, t) {
    return (r[0] - n[0]) * (t[1] - n[1]) - (t[0] - n[0]) * (r[1] - n[1]);
  }
};
var e = u;
e.neg = (n) => [-n[0], -n[1]], e.add = (n, r) => [n[0] + r[0], n[1] + r[1]], e.addScalar = (n, r) => [n[0] + r, n[1] + r], e.sub = (n, r) => [n[0] - r[0], n[1] - r[1]], e.subScalar = (n, r) => [n[0] - r, n[1] - r], e.vec = (n, r) => [r[0] - n[0], r[1] - n[1]], e.mul = (n, r) => [n[0] * r, n[1] * r], e.mulV = (n, r) => [n[0] * r[0], n[1] * r[1]], e.div = (n, r) => [n[0] / r, n[1] / r], e.divV = (n, r) => [n[0] / r[0], n[1] / r[1]], e.per = (n) => [n[1], -n[0]], e.dpr = (n, r) => n[0] * r[0] + n[1] * r[1], e.cpr = (n, r) => n[0] * r[1] - r[0] * n[1], e.len2 = (n) => n[0] * n[0] + n[1] * n[1], e.len = (n) => Math.hypot(n[0], n[1]), e.pry = (n, r) => u.dpr(n, r) / u.len(r), e.uni = (n) => u.div(n, u.len(n)), e.normalize = (n) => u.uni(n), e.tangent = (n, r) => u.normalize(u.sub(n, r)), e.dist2 = (n, r) => u.len2(u.sub(n, r)), e.dist = (n, r) => Math.hypot(n[1] - r[1], n[0] - r[0]), e.fastDist = (n, r) => {
  let t = [r[0] - n[0], r[1] - n[1]], m = [Math.abs(t[0]), Math.abs(t[1])], b2 = 1 / Math.max(m[0], m[1]);
  return b2 = b2 * (1.29289 - (m[0] + m[1]) * b2 * 0.29289), [t[0] * b2, t[1] * b2];
}, e.ang = (n, r) => Math.atan2(u.cpr(n, r), u.dpr(n, r)), e.angle = (n, r) => Math.atan2(r[1] - n[1], r[0] - n[0]), e.med = (n, r) => u.mul(u.add(n, r), 0.5), e.rot = (n, r) => [n[0] * Math.cos(r) - n[1] * Math.sin(r), n[0] * Math.sin(r) + n[1] * Math.cos(r)], e.rotWith = (n, r, t) => {
  if (t === 0)
    return n;
  let m = Math.sin(t), b2 = Math.cos(t), a = n[0] - r[0], s = n[1] - r[1], i = a * b2 - s * m, o2 = a * m + s * b2;
  return [i + r[0], o2 + r[1]];
}, e.isEqual = (n, r) => n[0] === r[0] && n[1] === r[1], e.lrp = (n, r, t) => u.add(n, u.mul(u.sub(r, n), t)), e.int = (n, r, t, m, b2 = 1) => {
  let a = (u.clamp(t, m) - t) / (m - t);
  return u.add(u.mul(n, 1 - a), u.mul(r, b2));
}, e.ang3 = (n, r, t) => {
  let m = u.vec(r, n), b2 = u.vec(r, t);
  return u.ang(m, b2);
}, e.abs = (n) => [Math.abs(n[0]), Math.abs(n[1])], e.rescale = (n, r) => {
  let t = u.len(n);
  return [r * n[0] / t, r * n[1] / t];
}, e.isLeft = (n, r, t) => (r[0] - n[0]) * (t[1] - n[1]) - (t[0] - n[0]) * (r[1] - n[1]), e.clockwise = (n, r, t) => u.isLeft(n, r, t) > 0, e.round = (n, r = 2) => n.map((t) => +t.toFixed(r)), e.nearestPointOnLineThroughPoint = (n, r, t) => u.add(n, u.mul(r, u.pry(u.sub(t, n), r))), e.distanceToLineThroughPoint = (n, r, t) => u.dist(t, u.nearestPointOnLineThroughPoint(n, r, t)), e.nearestPointOnLineSegment = (n, r, t, m = true) => {
  let b2 = u.sub(r, n), a = u.len(b2), s = u.div(b2, a), i = u.add(n, u.mul(s, u.pry(u.sub(t, n), s)));
  if (m) {
    let o2 = u.dist(n, i), c = u.dist(r, i);
    if (c < o2 && o2 > a)
      return r;
    if (o2 < c && c > a)
      return n;
  }
  return i;
}, e.distanceToLineSegment = (n, r, t, m = true) => u.dist(t, u.nearestPointOnLineSegment(n, r, t, m)), e.nudge = (n, r, t) => u.add(n, u.mul(u.uni(u.vec(n, r)), t)), e.nudgeAtAngle = (n, r, t) => [Math.cos(r) * t + n[0], Math.sin(r) * t + n[1]], e.toPrecision = (n, r = 4) => [+n[0].toPrecision(r), +n[1].toPrecision(r)], e.pointsBetween = (n, r, t = 6) => Array.from(Array(t)).map((m, b2) => {
  let a = b2 / (t - 1), s = Math.min(1, 0.5 + Math.abs(0.5 - a));
  return [...u.lrp(n, r, a), s];
});

// src/hooks/useZoomEvents.ts
function useZoomEvents(zoom, ref) {
  const rOriginPoint = useRef(void 0);
  const rPinchPoint = useRef(void 0);
  const rDelta = useRef([0, 0]);
  const { inputs: inputs2, callbacks } = useTLContext();
  useEffect(() => {
    const preventGesture = (event) => {
      event.preventDefault();
    };
    document.addEventListener("gesturestart", preventGesture);
    document.addEventListener("gesturechange", preventGesture);
    return () => {
      document.removeEventListener("gesturestart", preventGesture);
      document.removeEventListener("gesturechange", preventGesture);
    };
  }, []);
  useGesture({
    onWheel: ({ delta, event: e2 }) => {
      var _a, _b, _c, _d;
      if (e2.altKey && e2.buttons === 0) {
        const point = (_b = (_a = inputs2.pointer) == null ? void 0 : _a.point) != null ? _b : [inputs2.bounds.width / 2, inputs2.bounds.height / 2];
        const info2 = inputs2.pinch(point, point);
        (_c = callbacks.onZoom) == null ? void 0 : _c.call(callbacks, __spreadProps(__spreadValues({}, info2), { delta: [...point, -e2.deltaY] }), e2);
        return;
      }
      e2.preventDefault();
      if (inputs2.isPinching)
        return;
      if (e.isEqual(delta, [0, 0]))
        return;
      const info = inputs2.pan(delta, e2);
      (_d = callbacks.onPan) == null ? void 0 : _d.call(callbacks, info, e2);
    },
    onPinchStart: ({ origin, event }) => {
      var _a;
      const elm = ref.current;
      if (!elm || !(event.target === elm || elm.contains(event.target)))
        return;
      const info = inputs2.pinch(origin, origin);
      inputs2.isPinching = true;
      (_a = callbacks.onPinchStart) == null ? void 0 : _a.call(callbacks, info, event);
      rPinchPoint.current = info.point;
      rOriginPoint.current = info.origin;
      rDelta.current = [0, 0];
    },
    onPinchEnd: ({ origin, event }) => {
      var _a;
      const elm = ref.current;
      if (!(event.target === elm || (elm == null ? void 0 : elm.contains(event.target))))
        return;
      const info = inputs2.pinch(origin, origin);
      inputs2.isPinching = false;
      (_a = callbacks.onPinchEnd) == null ? void 0 : _a.call(callbacks, info, event);
      rPinchPoint.current = void 0;
      rOriginPoint.current = void 0;
      rDelta.current = [0, 0];
    },
    onPinch: ({ origin, offset, event }) => {
      var _a;
      const elm = ref.current;
      if (!(event.target === elm || (elm == null ? void 0 : elm.contains(event.target))))
        return;
      if (!rOriginPoint.current)
        return;
      const info = inputs2.pinch(origin, rOriginPoint.current);
      const trueDelta = e.sub(info.delta, rDelta.current);
      rDelta.current = info.delta;
      (_a = callbacks.onPinch) == null ? void 0 : _a.call(callbacks, __spreadProps(__spreadValues({}, info), {
        point: info.point,
        origin: rOriginPoint.current,
        delta: [...trueDelta, offset[0]]
      }), event);
      rPinchPoint.current = origin;
    }
  }, {
    target: ref,
    eventOptions: { passive: false },
    pinch: {
      from: zoom,
      scaleBounds: () => ({ from: inputs2.zoom, max: 5, min: 0.1 })
    }
  });
}

// src/hooks/useSafariFocusOutFix.tsx
import { useEffect as useEffect2 } from "react";

// src/types.ts
var TLBoundsEdge;
(function(TLBoundsEdge2) {
  TLBoundsEdge2["Top"] = "top_edge";
  TLBoundsEdge2["Right"] = "right_edge";
  TLBoundsEdge2["Bottom"] = "bottom_edge";
  TLBoundsEdge2["Left"] = "left_edge";
})(TLBoundsEdge || (TLBoundsEdge = {}));
var TLBoundsCorner;
(function(TLBoundsCorner2) {
  TLBoundsCorner2["TopLeft"] = "top_left_corner";
  TLBoundsCorner2["TopRight"] = "top_right_corner";
  TLBoundsCorner2["BottomRight"] = "bottom_right_corner";
  TLBoundsCorner2["BottomLeft"] = "bottom_left_corner";
})(TLBoundsCorner || (TLBoundsCorner = {}));

// src/utils/polyfills.ts
if (!String.prototype.replaceAll) {
  String.prototype.replaceAll = function(str, newStr) {
    if (Object.prototype.toString.call(str).toLowerCase() === "[object regexp]") {
      return this.replace(str, newStr);
    }
    return this.replace(new RegExp(str, "g"), newStr);
  };
}

// src/utils/utils.ts
var _Utils = class {
  static filterObject(obj, fn) {
    return Object.fromEntries(Object.entries(obj).filter(fn));
  }
  static lerp(y1, y2, mu) {
    mu = _Utils.clamp(mu, 0, 1);
    return y1 * (1 - mu) + y2 * mu;
  }
  static lerpColor(color1, color2, factor = 0.5) {
    function h2r(hex) {
      const result2 = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
      return [parseInt(result2[1], 16), parseInt(result2[2], 16), parseInt(result2[3], 16)];
    }
    function r2h(rgb) {
      return "#" + ((1 << 24) + (rgb[0] << 16) + (rgb[1] << 8) + rgb[2]).toString(16).slice(1);
    }
    const c1 = h2r(color1) || [0, 0, 0];
    const c2 = h2r(color2) || [0, 0, 0];
    const result = c1.slice();
    for (let i = 0; i < 3; i++) {
      result[i] = Math.round(result[i] + factor * (c2[i] - c1[i]));
    }
    return r2h(result);
  }
  static modulate(value, rangeA, rangeB, clamp2 = false) {
    const [fromLow, fromHigh] = rangeA;
    const [v0, v1] = rangeB;
    const result = v0 + (value - fromLow) / (fromHigh - fromLow) * (v1 - v0);
    return clamp2 ? v0 < v1 ? Math.max(Math.min(result, v1), v0) : Math.max(Math.min(result, v0), v1) : result;
  }
  static clamp(n, min, max) {
    return Math.max(min, typeof max !== "undefined" ? Math.min(n, max) : n);
  }
  static compress(s) {
    return s;
  }
  static decompress(s) {
    return s;
  }
  static deepClone(obj) {
    if (obj === null)
      return obj;
    if (Array.isArray(obj)) {
      return [...obj];
    }
    if (typeof obj === "object") {
      const clone = __spreadValues({}, obj);
      Object.keys(clone).forEach((key) => clone[key] = typeof obj[key] === "object" ? _Utils.deepClone(obj[key]) : obj[key]);
      return clone;
    }
    return obj;
  }
  static rng(seed = "") {
    let x = 0;
    let y = 0;
    let z = 0;
    let w2 = 0;
    function next() {
      const t = x ^ x << 11;
      x = y;
      y = z;
      z = w2;
      w2 ^= (w2 >>> 19 ^ t ^ t >>> 8) >>> 0;
      return w2 / 4294967296;
    }
    for (let k = 0; k < seed.length + 64; k++) {
      x ^= seed.charCodeAt(k) | 0;
      next();
    }
    return next;
  }
  static getRectangleSides(point, size, rotation = 0) {
    const center = [point[0] + size[0] / 2, point[1] + size[1] / 2];
    const tl = e.rotWith(point, center, rotation);
    const tr = e.rotWith(e.add(point, [size[0], 0]), center, rotation);
    const br = e.rotWith(e.add(point, size), center, rotation);
    const bl = e.rotWith(e.add(point, [0, size[1]]), center, rotation);
    return [
      ["top", [tl, tr]],
      ["right", [tr, br]],
      ["bottom", [br, bl]],
      ["left", [bl, tl]]
    ];
  }
  static getBoundsSides(bounds) {
    return this.getRectangleSides([bounds.minX, bounds.minY], [bounds.width, bounds.height]);
  }
  static shallowEqual(objA, objB) {
    if (objA === objB)
      return true;
    if (!objA || !objB)
      return false;
    const aKeys = Object.keys(objA);
    const bKeys = Object.keys(objB);
    const len = aKeys.length;
    if (bKeys.length !== len)
      return false;
    for (let i = 0; i < len; i++) {
      const key = aKeys[i];
      if (objA[key] !== objB[key] || !Object.prototype.hasOwnProperty.call(objB, key)) {
        return false;
      }
    }
    return true;
  }
  static getCircleTangentToPoint(C, r, P2, side) {
    const B = e.lrp(C, P2, 0.5);
    const r1 = e.dist(C, B);
    const delta = e.sub(B, C);
    const d = e.len(delta);
    if (!(d <= r + r1 && d >= Math.abs(r - r1))) {
      return null;
    }
    const a = (r * r - r1 * r1 + d * d) / (2 * d);
    const n = 1 / d;
    const p2 = e.add(C, e.mul(delta, a * n));
    const h2 = Math.sqrt(r * r - a * a);
    const k = e.mul(e.per(delta), h2 * n);
    return side === 0 ? e.add(p2, k) : e.sub(p2, k);
  }
  static getOuterTangentsOfCircles(C0, r0, C1, r1) {
    const a0 = e.angle(C0, C1);
    const d = e.dist(C0, C1);
    if (d < Math.abs(r1 - r0)) {
      return null;
    }
    const a1 = Math.acos((r0 - r1) / d);
    const t0 = a0 + a1;
    const t1 = a0 - a1;
    return [
      [C0[0] + r0 * Math.cos(t1), C0[1] + r0 * Math.sin(t1)],
      [C1[0] + r1 * Math.cos(t1), C1[1] + r1 * Math.sin(t1)],
      [C0[0] + r0 * Math.cos(t0), C0[1] + r0 * Math.sin(t0)],
      [C1[0] + r1 * Math.cos(t0), C1[1] + r1 * Math.sin(t0)]
    ];
  }
  static getClosestPointOnCircle(C, r, P2) {
    const v = e.sub(C, P2);
    return e.sub(C, e.mul(e.div(v, e.len(v)), r));
  }
  static circleFromThreePoints(A2, B, C) {
    const [x1, y1] = A2;
    const [x2, y2] = B;
    const [x3, y3] = C;
    const a = x1 * (y2 - y3) - y1 * (x2 - x3) + x2 * y3 - x3 * y2;
    const b2 = (x1 * x1 + y1 * y1) * (y3 - y2) + (x2 * x2 + y2 * y2) * (y1 - y3) + (x3 * x3 + y3 * y3) * (y2 - y1);
    const c = (x1 * x1 + y1 * y1) * (x2 - x3) + (x2 * x2 + y2 * y2) * (x3 - x1) + (x3 * x3 + y3 * y3) * (x1 - x2);
    const x = -b2 / (2 * a);
    const y = -c / (2 * a);
    return [x, y, Math.hypot(x - x1, y - y1)];
  }
  static perimeterOfEllipse(rx, ry) {
    const h2 = Math.pow(rx - ry, 2) / Math.pow(rx + ry, 2);
    const p2 = Math.PI * (rx + ry) * (1 + 3 * h2 / (10 + Math.sqrt(4 - 3 * h2)));
    return p2;
  }
  static shortAngleDist(a0, a1) {
    const max = Math.PI * 2;
    const da = (a1 - a0) % max;
    return 2 * da % max - da;
  }
  static longAngleDist(a0, a1) {
    return Math.PI * 2 - _Utils.shortAngleDist(a0, a1);
  }
  static lerpAngles(a0, a1, t) {
    return a0 + _Utils.shortAngleDist(a0, a1) * t;
  }
  static angleDelta(a0, a1) {
    return _Utils.shortAngleDist(a0, a1);
  }
  static getSweep(C, A2, B) {
    return _Utils.angleDelta(e.angle(C, A2), e.angle(C, B));
  }
  static rotatePoint(A2, B, angle) {
    const s = Math.sin(angle);
    const c = Math.cos(angle);
    const px = A2[0] - B[0];
    const py = A2[1] - B[1];
    const nx = px * c - py * s;
    const ny = px * s + py * c;
    return [nx + B[0], ny + B[1]];
  }
  static clampRadians(r) {
    return (Math.PI * 2 + r) % (Math.PI * 2);
  }
  static snapAngleToSegments(r, segments) {
    const seg = Math.PI * 2 / segments;
    return Math.floor((_Utils.clampRadians(r) + seg / 2) / seg) * seg;
  }
  static isAngleBetween(a, b2, c) {
    if (c === a || c === b2)
      return true;
    const PI2 = Math.PI * 2;
    const AB = (b2 - a + PI2) % PI2;
    const AC = (c - a + PI2) % PI2;
    return AB <= Math.PI !== AC > AB;
  }
  static degreesToRadians(d) {
    return d * Math.PI / 180;
  }
  static radiansToDegrees(r) {
    return r * 180 / Math.PI;
  }
  static getArcLength(C, r, A2, B) {
    const sweep = _Utils.getSweep(C, A2, B);
    return r * (2 * Math.PI) * (sweep / (2 * Math.PI));
  }
  static getArcDashOffset(C, r, A2, B, step) {
    const del0 = _Utils.getSweep(C, A2, B);
    const len0 = _Utils.getArcLength(C, r, A2, B);
    const off0 = del0 < 0 ? len0 : 2 * Math.PI * C[2] - len0;
    return -off0 / 2 + step;
  }
  static getEllipseDashOffset(A2, step) {
    const c = 2 * Math.PI * A2[2];
    return -c / 2 + -step;
  }
  static getTLBezierCurveSegments(points, tension = 0.4) {
    const len = points.length;
    const cpoints = [...points];
    if (len < 2) {
      throw Error("Curve must have at least two points.");
    }
    for (let i = 1; i < len - 1; i++) {
      const p0 = points[i - 1];
      const p1 = points[i];
      const p2 = points[i + 1];
      const pdx = p2[0] - p0[0];
      const pdy = p2[1] - p0[1];
      const pd = Math.hypot(pdx, pdy);
      const nx = pdx / pd;
      const ny = pdy / pd;
      const dp = Math.hypot(p1[0] - p0[0], p1[1] - p0[1]);
      const dn = Math.hypot(p1[0] - p2[0], p1[1] - p2[1]);
      cpoints[i] = [
        p1[0] - nx * dp * tension,
        p1[1] - ny * dp * tension,
        p1[0] + nx * dn * tension,
        p1[1] + ny * dn * tension,
        nx,
        ny
      ];
    }
    const d0 = Math.hypot(points[0][0] + cpoints[1][0]);
    cpoints[0][2] = (points[0][0] + cpoints[1][0]) / 2;
    cpoints[0][3] = (points[0][1] + cpoints[1][1]) / 2;
    cpoints[0][4] = (cpoints[1][0] - points[0][0]) / d0;
    cpoints[0][5] = (cpoints[1][1] - points[0][1]) / d0;
    const d1 = Math.hypot(points[len - 1][1] + cpoints[len - 1][1]);
    cpoints[len - 1][0] = (points[len - 1][0] + cpoints[len - 2][2]) / 2;
    cpoints[len - 1][1] = (points[len - 1][1] + cpoints[len - 2][3]) / 2;
    cpoints[len - 1][4] = (cpoints[len - 2][2] - points[len - 1][0]) / -d1;
    cpoints[len - 1][5] = (cpoints[len - 2][3] - points[len - 1][1]) / -d1;
    const results = [];
    for (let i = 1; i < cpoints.length; i++) {
      results.push({
        start: points[i - 1].slice(0, 2),
        tangentStart: cpoints[i - 1].slice(2, 4),
        normalStart: cpoints[i - 1].slice(4, 6),
        pressureStart: 2 + ((i - 1) % 2 === 0 ? 1.5 : 0),
        end: points[i].slice(0, 2),
        tangentEnd: cpoints[i].slice(0, 2),
        normalEnd: cpoints[i].slice(4, 6),
        pressureEnd: 2 + (i % 2 === 0 ? 1.5 : 0)
      });
    }
    return results;
  }
  static computePointOnCurve(t, points) {
    if (t === 0) {
      return points[0];
    }
    const order = points.length - 1;
    if (t === 1) {
      return points[order];
    }
    const mt = 1 - t;
    let p2 = points;
    if (order === 0) {
      return points[0];
    }
    if (order === 1) {
      return [mt * p2[0][0] + t * p2[1][0], mt * p2[0][1] + t * p2[1][1]];
    }
    const mt2 = mt * mt;
    const t2 = t * t;
    let a;
    let b2;
    let c;
    let d = 0;
    if (order === 2) {
      p2 = [p2[0], p2[1], p2[2], [0, 0]];
      a = mt2;
      b2 = mt * t * 2;
      c = t2;
    } else {
      a = mt2 * mt;
      b2 = mt2 * t * 3;
      c = mt * t2 * 3;
      d = t * t2;
    }
    return [
      a * p2[0][0] + b2 * p2[1][0] + c * p2[2][0] + d * p2[3][0],
      a * p2[0][1] + b2 * p2[1][1] + c * p2[2][1] + d * p2[3][1]
    ];
  }
  static cubicBezier(tx, x1, y1, x2, y2) {
    const x0 = 0;
    const y0 = 0;
    const x3 = 1;
    const y3 = 1;
    const A2 = x3 - 3 * x2 + 3 * x1 - x0;
    const B = 3 * x2 - 6 * x1 + 3 * x0;
    const C = 3 * x1 - 3 * x0;
    const D = x0;
    const E2 = y3 - 3 * y2 + 3 * y1 - y0;
    const F = 3 * y2 - 6 * y1 + 3 * y0;
    const G = 3 * y1 - 3 * y0;
    const H = y0;
    const iterations = 5;
    let i;
    let slope;
    let x;
    let t = tx;
    for (i = 0; i < iterations; i++) {
      x = A2 * t * t * t + B * t * t + C * t + D;
      slope = 1 / (3 * A2 * t * t + 2 * B * t + C);
      t -= (x - tx) * slope;
      t = t > 1 ? 1 : t < 0 ? 0 : t;
    }
    return Math.abs(E2 * t * t * t + F * t * t + G * t * H);
  }
  static getSpline(pts, k = 0.5) {
    let p0;
    let [p1, p2, p3] = pts;
    const results = [];
    for (let i = 1, len = pts.length; i < len; i++) {
      p0 = p1;
      p1 = p2;
      p2 = p3;
      p3 = pts[i + 2] ? pts[i + 2] : p2;
      results.push({
        cp1x: p1[0] + (p2[0] - p0[0]) / 6 * k,
        cp1y: p1[1] + (p2[1] - p0[1]) / 6 * k,
        cp2x: p2[0] - (p3[0] - p1[0]) / 6 * k,
        cp2y: p2[1] - (p3[1] - p1[1]) / 6 * k,
        px: pts[i][0],
        py: pts[i][1]
      });
    }
    return results;
  }
  static getCurvePoints(pts, tension = 0.5, isClosed = false, numOfSegments = 3) {
    const _pts = [...pts];
    const len = pts.length;
    const res = [];
    let t1x, t2x, t1y, t2y, c1, c2, c3, c4, st, st2, st3;
    if (isClosed) {
      _pts.unshift(_pts[len - 1]);
      _pts.push(_pts[0]);
    } else {
      _pts.unshift(_pts[0]);
      _pts.push(_pts[len - 1]);
    }
    for (let i = 1; i < _pts.length - 2; i++) {
      for (let t = 0; t <= numOfSegments; t++) {
        st = t / numOfSegments;
        st2 = Math.pow(st, 2);
        st3 = Math.pow(st, 3);
        c1 = 2 * st3 - 3 * st2 + 1;
        c2 = -(2 * st3) + 3 * st2;
        c3 = st3 - 2 * st2 + st;
        c4 = st3 - st2;
        t1x = (_pts[i + 1][0] - _pts[i - 1][0]) * tension;
        t2x = (_pts[i + 2][0] - _pts[i][0]) * tension;
        t1y = (_pts[i + 1][1] - _pts[i - 1][1]) * tension;
        t2y = (_pts[i + 2][1] - _pts[i][1]) * tension;
        res.push([
          c1 * _pts[i][0] + c2 * _pts[i + 1][0] + c3 * t1x + c4 * t2x,
          c1 * _pts[i][1] + c2 * _pts[i + 1][1] + c3 * t1y + c4 * t2y
        ]);
      }
    }
    res.push(pts[pts.length - 1]);
    return res;
  }
  static simplify(points, tolerance = 1) {
    const len = points.length;
    const a = points[0];
    const b2 = points[len - 1];
    const [x1, y1] = a;
    const [x2, y2] = b2;
    if (len > 2) {
      let distance = 0;
      let index = 0;
      const max = Math.hypot(y2 - y1, x2 - x1);
      for (let i = 1; i < len - 1; i++) {
        const [x0, y0] = points[i];
        const d = Math.abs((y2 - y1) * x0 - (x2 - x1) * y0 + x2 * y1 - y2 * x1) / max;
        if (distance > d)
          continue;
        distance = d;
        index = i;
      }
      if (distance > tolerance) {
        const l0 = _Utils.simplify(points.slice(0, index + 1), tolerance);
        const l1 = _Utils.simplify(points.slice(index + 1), tolerance);
        return l0.concat(l1.slice(1));
      }
    }
    return [a, b2];
  }
  static pointInCircle(A2, C, r) {
    return e.dist(A2, C) <= r;
  }
  static pointInEllipse(A2, C, rx, ry, rotation = 0) {
    rotation = rotation || 0;
    const cos = Math.cos(rotation);
    const sin = Math.sin(rotation);
    const delta = e.sub(A2, C);
    const tdx = cos * delta[0] + sin * delta[1];
    const tdy = sin * delta[0] - cos * delta[1];
    return tdx * tdx / (rx * rx) + tdy * tdy / (ry * ry) <= 1;
  }
  static pointInRect(point, size) {
    return !(point[0] < size[0] || point[0] > point[0] + size[0] || point[1] < size[1] || point[1] > point[1] + size[1]);
  }
  static pointInPolygon(p2, points) {
    let wn = 0;
    points.forEach((a, i) => {
      const b2 = points[(i + 1) % points.length];
      if (a[1] <= p2[1]) {
        if (b2[1] > p2[1] && e.cross(a, b2, p2) > 0) {
          wn += 1;
        }
      } else if (b2[1] <= p2[1] && e.cross(a, b2, p2) < 0) {
        wn -= 1;
      }
    });
    return wn !== 0;
  }
  static expandBounds(bounds, delta) {
    return {
      minX: bounds.minX - delta,
      minY: bounds.minY - delta,
      maxX: bounds.maxX + delta,
      maxY: bounds.maxY + delta,
      width: bounds.width + delta * 2,
      height: bounds.height + delta * 2
    };
  }
  static pointInBounds(A2, b2) {
    return !(A2[0] < b2.minX || A2[0] > b2.maxX || A2[1] < b2.minY || A2[1] > b2.maxY);
  }
  static boundsCollide(a, b2) {
    return !(a.maxX < b2.minX || a.minX > b2.maxX || a.maxY < b2.minY || a.minY > b2.maxY);
  }
  static boundsContain(a, b2) {
    return a.minX < b2.minX && a.minY < b2.minY && a.maxY > b2.maxY && a.maxX > b2.maxX;
  }
  static boundsContained(a, b2) {
    return _Utils.boundsContain(b2, a);
  }
  static boundsAreEqual(a, b2) {
    return !(b2.maxX !== a.maxX || b2.minX !== a.minX || b2.maxY !== a.maxY || b2.minY !== a.minY);
  }
  static getBoundsFromPoints(points, rotation = 0) {
    let minX = Infinity;
    let minY = Infinity;
    let maxX = -Infinity;
    let maxY = -Infinity;
    if (points.length < 2) {
      minX = 0;
      minY = 0;
      maxX = 1;
      maxY = 1;
    } else {
      for (const [x, y] of points) {
        minX = Math.min(x, minX);
        minY = Math.min(y, minY);
        maxX = Math.max(x, maxX);
        maxY = Math.max(y, maxY);
      }
    }
    if (rotation !== 0) {
      return _Utils.getBoundsFromPoints(points.map((pt) => e.rotWith(pt, [(minX + maxX) / 2, (minY + maxY) / 2], rotation)));
    }
    return {
      minX,
      minY,
      maxX,
      maxY,
      width: Math.max(1, maxX - minX),
      height: Math.max(1, maxY - minY)
    };
  }
  static centerBounds(bounds, point) {
    const boundsCenter = this.getBoundsCenter(bounds);
    const dx = point[0] - boundsCenter[0];
    const dy = point[1] - boundsCenter[1];
    return this.translateBounds(bounds, [dx, dy]);
  }
  static translateBounds(bounds, delta) {
    return {
      minX: bounds.minX + delta[0],
      minY: bounds.minY + delta[1],
      maxX: bounds.maxX + delta[0],
      maxY: bounds.maxY + delta[1],
      width: bounds.width,
      height: bounds.height
    };
  }
  static rotateBounds(bounds, center, rotation) {
    const [minX, minY] = e.rotWith([bounds.minX, bounds.minY], center, rotation);
    const [maxX, maxY] = e.rotWith([bounds.maxX, bounds.maxY], center, rotation);
    return {
      minX,
      minY,
      maxX,
      maxY,
      width: bounds.width,
      height: bounds.height
    };
  }
  static getRotatedEllipseBounds(x, y, rx, ry, rotation = 0) {
    const c = Math.cos(rotation);
    const s = Math.sin(rotation);
    const w2 = Math.hypot(rx * c, ry * s);
    const h2 = Math.hypot(rx * s, ry * c);
    return {
      minX: x + rx - w2,
      minY: y + ry - h2,
      maxX: x + rx + w2,
      maxY: y + ry + h2,
      width: w2 * 2,
      height: h2 * 2
    };
  }
  static getExpandedBounds(a, b2) {
    const minX = Math.min(a.minX, b2.minX);
    const minY = Math.min(a.minY, b2.minY);
    const maxX = Math.max(a.maxX, b2.maxX);
    const maxY = Math.max(a.maxY, b2.maxY);
    const width = Math.abs(maxX - minX);
    const height = Math.abs(maxY - minY);
    return { minX, minY, maxX, maxY, width, height };
  }
  static getCommonBounds(bounds) {
    if (bounds.length < 2)
      return bounds[0];
    let result = bounds[0];
    for (let i = 1; i < bounds.length; i++) {
      result = _Utils.getExpandedBounds(result, bounds[i]);
    }
    return result;
  }
  static getRotatedCorners(b2, rotation = 0) {
    const center = [b2.minX + b2.width / 2, b2.minY + b2.height / 2];
    return [
      [b2.minX, b2.minY],
      [b2.maxX, b2.minY],
      [b2.maxX, b2.maxY],
      [b2.minX, b2.maxY]
    ].map((point) => e.rotWith(point, center, rotation));
  }
  static getTransformedBoundingBox(bounds, handle, delta, rotation = 0, isAspectRatioLocked = false) {
    const [ax0, ay0] = [bounds.minX, bounds.minY];
    const [ax1, ay1] = [bounds.maxX, bounds.maxY];
    let [bx0, by0] = [bounds.minX, bounds.minY];
    let [bx1, by1] = [bounds.maxX, bounds.maxY];
    if (handle === "center") {
      return {
        minX: bx0 + delta[0],
        minY: by0 + delta[1],
        maxX: bx1 + delta[0],
        maxY: by1 + delta[1],
        width: bx1 - bx0,
        height: by1 - by0,
        scaleX: 1,
        scaleY: 1
      };
    }
    const [dx, dy] = e.rot(delta, -rotation);
    switch (handle) {
      case TLBoundsEdge.Top:
      case TLBoundsCorner.TopLeft:
      case TLBoundsCorner.TopRight: {
        by0 += dy;
        break;
      }
      case TLBoundsEdge.Bottom:
      case TLBoundsCorner.BottomLeft:
      case TLBoundsCorner.BottomRight: {
        by1 += dy;
        break;
      }
    }
    switch (handle) {
      case TLBoundsEdge.Left:
      case TLBoundsCorner.TopLeft:
      case TLBoundsCorner.BottomLeft: {
        bx0 += dx;
        break;
      }
      case TLBoundsEdge.Right:
      case TLBoundsCorner.TopRight:
      case TLBoundsCorner.BottomRight: {
        bx1 += dx;
        break;
      }
    }
    const aw = ax1 - ax0;
    const ah = ay1 - ay0;
    const scaleX = (bx1 - bx0) / aw;
    const scaleY = (by1 - by0) / ah;
    const flipX = scaleX < 0;
    const flipY = scaleY < 0;
    const bw = Math.abs(bx1 - bx0);
    const bh = Math.abs(by1 - by0);
    if (isAspectRatioLocked) {
      const ar = aw / ah;
      const isTall = ar < bw / bh;
      const tw = bw * (scaleY < 0 ? 1 : -1) * (1 / ar);
      const th = bh * (scaleX < 0 ? 1 : -1) * ar;
      switch (handle) {
        case TLBoundsCorner.TopLeft: {
          if (isTall)
            by0 = by1 + tw;
          else
            bx0 = bx1 + th;
          break;
        }
        case TLBoundsCorner.TopRight: {
          if (isTall)
            by0 = by1 + tw;
          else
            bx1 = bx0 - th;
          break;
        }
        case TLBoundsCorner.BottomRight: {
          if (isTall)
            by1 = by0 - tw;
          else
            bx1 = bx0 - th;
          break;
        }
        case TLBoundsCorner.BottomLeft: {
          if (isTall)
            by1 = by0 - tw;
          else
            bx0 = bx1 + th;
          break;
        }
        case TLBoundsEdge.Bottom:
        case TLBoundsEdge.Top: {
          const m = (bx0 + bx1) / 2;
          const w2 = bh * ar;
          bx0 = m - w2 / 2;
          bx1 = m + w2 / 2;
          break;
        }
        case TLBoundsEdge.Left:
        case TLBoundsEdge.Right: {
          const m = (by0 + by1) / 2;
          const h2 = bw / ar;
          by0 = m - h2 / 2;
          by1 = m + h2 / 2;
          break;
        }
      }
    }
    if (rotation % (Math.PI * 2) !== 0) {
      let cv = [0, 0];
      const c0 = e.med([ax0, ay0], [ax1, ay1]);
      const c1 = e.med([bx0, by0], [bx1, by1]);
      switch (handle) {
        case TLBoundsCorner.TopLeft: {
          cv = e.sub(e.rotWith([bx1, by1], c1, rotation), e.rotWith([ax1, ay1], c0, rotation));
          break;
        }
        case TLBoundsCorner.TopRight: {
          cv = e.sub(e.rotWith([bx0, by1], c1, rotation), e.rotWith([ax0, ay1], c0, rotation));
          break;
        }
        case TLBoundsCorner.BottomRight: {
          cv = e.sub(e.rotWith([bx0, by0], c1, rotation), e.rotWith([ax0, ay0], c0, rotation));
          break;
        }
        case TLBoundsCorner.BottomLeft: {
          cv = e.sub(e.rotWith([bx1, by0], c1, rotation), e.rotWith([ax1, ay0], c0, rotation));
          break;
        }
        case TLBoundsEdge.Top: {
          cv = e.sub(e.rotWith(e.med([bx0, by1], [bx1, by1]), c1, rotation), e.rotWith(e.med([ax0, ay1], [ax1, ay1]), c0, rotation));
          break;
        }
        case TLBoundsEdge.Left: {
          cv = e.sub(e.rotWith(e.med([bx1, by0], [bx1, by1]), c1, rotation), e.rotWith(e.med([ax1, ay0], [ax1, ay1]), c0, rotation));
          break;
        }
        case TLBoundsEdge.Bottom: {
          cv = e.sub(e.rotWith(e.med([bx0, by0], [bx1, by0]), c1, rotation), e.rotWith(e.med([ax0, ay0], [ax1, ay0]), c0, rotation));
          break;
        }
        case TLBoundsEdge.Right: {
          cv = e.sub(e.rotWith(e.med([bx0, by0], [bx0, by1]), c1, rotation), e.rotWith(e.med([ax0, ay0], [ax0, ay1]), c0, rotation));
          break;
        }
      }
      ;
      [bx0, by0] = e.sub([bx0, by0], cv);
      [bx1, by1] = e.sub([bx1, by1], cv);
    }
    if (bx1 < bx0) {
      ;
      [bx1, bx0] = [bx0, bx1];
    }
    if (by1 < by0) {
      ;
      [by1, by0] = [by0, by1];
    }
    return {
      minX: bx0,
      minY: by0,
      maxX: bx1,
      maxY: by1,
      width: bx1 - bx0,
      height: by1 - by0,
      scaleX: (bx1 - bx0) / (ax1 - ax0 || 1) * (flipX ? -1 : 1),
      scaleY: (by1 - by0) / (ay1 - ay0 || 1) * (flipY ? -1 : 1)
    };
  }
  static getTransformAnchor(type, isFlippedX, isFlippedY) {
    let anchor = type;
    switch (type) {
      case TLBoundsCorner.TopLeft: {
        if (isFlippedX && isFlippedY) {
          anchor = TLBoundsCorner.BottomRight;
        } else if (isFlippedX) {
          anchor = TLBoundsCorner.TopRight;
        } else if (isFlippedY) {
          anchor = TLBoundsCorner.BottomLeft;
        } else {
          anchor = TLBoundsCorner.BottomRight;
        }
        break;
      }
      case TLBoundsCorner.TopRight: {
        if (isFlippedX && isFlippedY) {
          anchor = TLBoundsCorner.BottomLeft;
        } else if (isFlippedX) {
          anchor = TLBoundsCorner.TopLeft;
        } else if (isFlippedY) {
          anchor = TLBoundsCorner.BottomRight;
        } else {
          anchor = TLBoundsCorner.BottomLeft;
        }
        break;
      }
      case TLBoundsCorner.BottomRight: {
        if (isFlippedX && isFlippedY) {
          anchor = TLBoundsCorner.TopLeft;
        } else if (isFlippedX) {
          anchor = TLBoundsCorner.BottomLeft;
        } else if (isFlippedY) {
          anchor = TLBoundsCorner.TopRight;
        } else {
          anchor = TLBoundsCorner.TopLeft;
        }
        break;
      }
      case TLBoundsCorner.BottomLeft: {
        if (isFlippedX && isFlippedY) {
          anchor = TLBoundsCorner.TopRight;
        } else if (isFlippedX) {
          anchor = TLBoundsCorner.BottomRight;
        } else if (isFlippedY) {
          anchor = TLBoundsCorner.TopLeft;
        } else {
          anchor = TLBoundsCorner.TopRight;
        }
        break;
      }
    }
    return anchor;
  }
  static getRelativeTransformedBoundingBox(bounds, initialBounds, initialShapeBounds, isFlippedX, isFlippedY) {
    const nx = (isFlippedX ? initialBounds.maxX - initialShapeBounds.maxX : initialShapeBounds.minX - initialBounds.minX) / initialBounds.width;
    const ny = (isFlippedY ? initialBounds.maxY - initialShapeBounds.maxY : initialShapeBounds.minY - initialBounds.minY) / initialBounds.height;
    const nw = initialShapeBounds.width / initialBounds.width;
    const nh = initialShapeBounds.height / initialBounds.height;
    const minX = bounds.minX + bounds.width * nx;
    const minY = bounds.minY + bounds.height * ny;
    const width = bounds.width * nw;
    const height = bounds.height * nh;
    return {
      minX,
      minY,
      maxX: minX + width,
      maxY: minY + height,
      width,
      height
    };
  }
  static getRotatedSize(size, rotation) {
    const center = e.div(size, 2);
    const points = [[0, 0], [size[0], 0], size, [0, size[1]]].map((point) => e.rotWith(point, center, rotation));
    const bounds = _Utils.getBoundsFromPoints(points);
    return [bounds.width, bounds.height];
  }
  static getBoundsCenter(bounds) {
    return [bounds.minX + bounds.width / 2, bounds.minY + bounds.height / 2];
  }
  static getBoundsWithCenter(bounds) {
    const center = _Utils.getBoundsCenter(bounds);
    return __spreadProps(__spreadValues({}, bounds), {
      midX: center[0],
      midY: center[1]
    });
  }
  static removeDuplicatePoints(points) {
    return points.reduce((acc, pt, i) => {
      if (i === 0 || !e.isEqual(pt, acc[i - 1])) {
        acc.push(pt);
      }
      return acc;
    }, []);
  }
  static getFromCache(cache, item, getNext) {
    let value = cache.get(item);
    if (value === void 0) {
      cache.set(item, getNext());
      value = cache.get(item);
      if (value === void 0) {
        throw Error("Cache did not include item!");
      }
    }
    return value;
  }
  static uniqueId(a = "") {
    return a ? ((Number(a) ^ Math.random() * 16) >> Number(a) / 4).toString(16) : `${1e7}-${1e3}-${4e3}-${8e3}-${1e11}`.replace(/[018]/g, _Utils.uniqueId);
  }
  static rotateArray(arr, offset) {
    return arr.map((_, i) => arr[(i + offset) % arr.length]);
  }
  static deepCompareArrays(a, b2) {
    if ((a == null ? void 0 : a.length) !== (b2 == null ? void 0 : b2.length))
      return false;
    return _Utils.deepCompare(a, b2);
  }
  static deepCompare(a, b2) {
    return a === b2 || JSON.stringify(a) === JSON.stringify(b2);
  }
  static arrsIntersect(a, b2, fn) {
    return a.some((item) => b2.includes(fn ? fn(item) : item));
  }
  static uniqueArray(...items) {
    return Array.from(new Set(items).values());
  }
  static setToArray(set) {
    return Array.from(set.values());
  }
  static debounce(fn, ms = 0) {
    let timeoutId;
    return function(...args) {
      clearTimeout(timeoutId);
      timeoutId = setTimeout(() => fn.apply(args), ms);
    };
  }
  static getSvgPathFromStroke(points, closed = true) {
    if (!points.length) {
      return "";
    }
    const max = points.length - 1;
    return points.reduce((acc, point, i, arr) => {
      if (i === max) {
        if (closed) {
          acc.push("Z");
        }
      } else {
        acc.push(point, e.med(point, arr[i + 1]));
      }
      return acc;
    }, ["M", points[0], "Q"]).join(" ").replaceAll(this.TRIM_NUMBERS, "$1");
  }
  static getPerfectDashProps(length, strokeWidth, style, snap = 1, outset = true) {
    let dashLength;
    let strokeDashoffset;
    let ratio;
    if (style.toLowerCase() === "dashed") {
      dashLength = strokeWidth * 2;
      ratio = 1;
      strokeDashoffset = outset ? (dashLength / 2).toString() : "0";
    } else if (style.toLowerCase() === "dotted") {
      dashLength = strokeWidth / 100;
      ratio = 100;
      strokeDashoffset = "0";
    } else {
      return {
        strokeDasharray: "none",
        strokeDashoffset: "none"
      };
    }
    let dashes = Math.floor(length / dashLength / (2 * ratio));
    dashes -= dashes % snap;
    dashes = Math.max(dashes, 4);
    const gapLength = Math.max(dashLength, (length - dashes * dashLength) / (outset ? dashes : dashes - 1));
    return {
      strokeDasharray: [dashLength, gapLength].join(" "),
      strokeDashoffset
    };
  }
  static isMobileSize() {
    if (typeof window === "undefined")
      return false;
    return window.innerWidth < 768;
  }
  static isMobileSafari() {
    if (typeof window === "undefined")
      return false;
    const ua = window.navigator.userAgent;
    const iOS = !!ua.match(/iPad/i) || !!ua.match(/iPhone/i);
    const webkit = !!ua.match(/WebKit/i);
    return iOS && webkit && !ua.match(/CriOS/i);
  }
  static throttle(func, limit) {
    let inThrottle;
    let lastResult;
    return function(...args) {
      if (!inThrottle) {
        inThrottle = true;
        setTimeout(() => inThrottle = false, limit);
        lastResult = func(...args);
      }
      return lastResult;
    };
  }
  static isDarwin() {
    return /Mac|iPod|iPhone|iPad/.test(window.navigator.platform);
  }
  static metaKey(e2) {
    return _Utils.isDarwin() ? e2.metaKey : e2.ctrlKey;
  }
};
var Utils = _Utils;
Utils.deepMerge = (target, patch) => {
  const result = __spreadValues({}, target);
  const entries = Object.entries(patch);
  for (const [key, value] of entries)
    result[key] = value === Object(value) && !Array.isArray(value) ? _Utils.deepMerge(result[key], value) : value;
  return result;
};
Utils.getSnapPoints = (bounds, others, distance, isCareful) => {
  const A2 = __spreadValues({}, bounds);
  const offset = [0, 0];
  const snapLines = [];
  let xs = null;
  let ys = null;
  const fxs = [A2.midX, A2.minX, A2.maxX];
  const fys = [A2.midY, A2.minY, A2.maxY];
  for (const B of others) {
    if (!xs) {
      const txs = [B.midX, B.minX, B.maxX];
      fxs.forEach((f, i) => txs.forEach((t, k) => {
        if (xs || !(isCareful || i === k))
          return;
        if (Math.abs(t - f) < distance) {
          xs = { B, i };
          offset[0] = [
            A2.midX - t,
            A2.midX - (t + A2.width / 2),
            A2.midX - (t - A2.width / 2)
          ][i];
          A2.minX -= offset[0];
          A2.midX -= offset[0];
          A2.maxX -= offset[0];
        }
      }));
    }
    if (!ys) {
      const tys = [B.midY, B.minY, B.maxY];
      fys.forEach((f, i) => tys.forEach((t, k) => {
        if (ys || !(isCareful || i === k))
          return;
        if (Math.abs(t - f) < distance) {
          ys = { B, i };
          offset[1] = [
            A2.midY - t,
            A2.midY - (t + A2.height / 2),
            A2.midY - (t - A2.height / 2)
          ][i];
          A2.minY -= offset[1];
          A2.midY -= offset[1];
          A2.maxY -= offset[1];
        }
      }));
    }
    if (xs && ys)
      break;
  }
  if (xs) {
    const { i, B } = xs;
    const x = [A2.midX, A2.minX, A2.maxX][i % 3];
    snapLines.push(i === 0 ? [
      [x, A2.midY],
      [x, B.minY],
      [x, B.maxY]
    ] : [
      [x, A2.minY],
      [x, A2.maxY],
      [x, B.minY],
      [x, B.maxY]
    ]);
  }
  if (ys) {
    const { i, B } = ys;
    const y = [A2.midY, A2.minY, A2.maxY][i % 3];
    snapLines.push(i === 0 ? [
      [A2.midX, y],
      [B.minX, y],
      [B.maxX, y]
    ] : [
      [A2.minX, y],
      [A2.maxX, y],
      [B.minX, y],
      [B.maxX, y]
    ]);
  }
  return { offset, snapLines };
};
Utils.TRIM_NUMBERS = /(\s?[A-Z]?,?-?[0-9]*\.[0-9]{0,2})(([0-9]|e|-)*)/g;

// src/utils/svg.ts
var _Svg = class {
};
var Svg = _Svg;
Svg.ellipse = (A2, r) => {
  return `M ${A2[0] - r},${A2[1]}
      a ${r},${r} 0 1,0 ${r * 2},0
      a ${r},${r} 0 1,0 -${r * 2},0 `;
};
Svg.moveTo = (v) => {
  return `M ${v[0]},${v[1]} `;
};
Svg.lineTo = (v) => {
  return `L ${v[0]},${v[1]} `;
};
Svg.line = (a, ...pts) => {
  return _Svg.moveTo(a) + pts.map((p2) => _Svg.lineTo(p2)).join();
};
Svg.hLineTo = (v) => {
  return `H ${v[0]},${v[1]} `;
};
Svg.vLineTo = (v) => {
  return `V ${v[0]},${v[1]} `;
};
Svg.bezierTo = (A2, B, C) => {
  return `C ${A2[0]},${A2[1]} ${B[0]},${B[1]} ${C[0]},${C[1]} `;
};
Svg.arcTo = (C, r, A2, B) => {
  return [
    _Svg.moveTo(A2),
    "A",
    r,
    r,
    0,
    0,
    Utils.getArcLength(C, r, A2, B) > 0 ? "1" : "0",
    B[0],
    B[1]
  ].join(" ");
};
Svg.closePath = () => {
  return "Z";
};
Svg.rectTo = (A2) => {
  return ["R", A2[0], A2[1]].join(" ");
};
Svg.getPointAtLength = (path, length) => {
  const point = path.getPointAtLength(length);
  return [point.x, point.y];
};

// src/utils/index.ts
var utils_default = Utils;

// src/hooks/useSafariFocusOutFix.tsx
function useSafariFocusOutFix() {
  const { callbacks } = useTLContext();
  useEffect2(() => {
    function handleFocusOut() {
      var _a;
      (_a = callbacks.onShapeBlur) == null ? void 0 : _a.call(callbacks);
    }
    if (utils_default.isMobileSafari()) {
      document.addEventListener("focusout", handleFocusOut);
      return () => document.removeEventListener("focusout", handleFocusOut);
    }
    return () => null;
  }, [callbacks]);
}

// src/hooks/useCanvasEvents.tsx
import {
  useCallback
} from "react";
function useCanvasEvents() {
  const { callbacks, inputs: inputs2 } = useTLContext();
  const onPointerDown = useCallback((e2) => {
    var _a, _b;
    if (e2.button !== 0)
      return;
    if (!inputs2.pointerIsValid(e2))
      return;
    e2.currentTarget.setPointerCapture(e2.pointerId);
    const info = inputs2.pointerDown(e2, "canvas");
    if (e2.button === 0) {
      (_a = callbacks.onPointCanvas) == null ? void 0 : _a.call(callbacks, info, e2);
      (_b = callbacks.onPointerDown) == null ? void 0 : _b.call(callbacks, info, e2);
    }
  }, [callbacks, inputs2]);
  const onPointerMove = useCallback((e2) => {
    var _a, _b;
    if (!inputs2.pointerIsValid(e2))
      return;
    const info = inputs2.pointerMove(e2, "canvas");
    if (e2.currentTarget.hasPointerCapture(e2.pointerId)) {
      (_a = callbacks.onDragCanvas) == null ? void 0 : _a.call(callbacks, info, e2);
    }
    (_b = callbacks.onPointerMove) == null ? void 0 : _b.call(callbacks, info, e2);
  }, [callbacks, inputs2]);
  const onPointerUp = useCallback((e2) => {
    var _a, _b, _c, _d;
    if (e2.button !== 0)
      return;
    if (!inputs2.pointerIsValid(e2))
      return;
    const isDoubleClick = inputs2.isDoubleClick();
    const info = inputs2.pointerUp(e2, "canvas");
    if (e2.currentTarget.hasPointerCapture(e2.pointerId)) {
      (_a = e2.currentTarget) == null ? void 0 : _a.releasePointerCapture(e2.pointerId);
    }
    if (isDoubleClick && !(info.altKey || info.metaKey)) {
      (_b = callbacks.onDoubleClickCanvas) == null ? void 0 : _b.call(callbacks, info, e2);
    }
    (_c = callbacks.onReleaseCanvas) == null ? void 0 : _c.call(callbacks, info, e2);
    (_d = callbacks.onPointerUp) == null ? void 0 : _d.call(callbacks, info, e2);
  }, [callbacks, inputs2]);
  return {
    onPointerDown,
    onPointerMove,
    onPointerUp
  };
}

// src/hooks/useShapeEvents.tsx
import {
  useCallback as useCallback2,
  useContext as useContext2
} from "react";
function useShapeEvents(id, disable = false) {
  const { rPageState, rSelectionBounds, callbacks, inputs: inputs2 } = useContext2(TLContext);
  const onPointerDown = useCallback2((e2) => {
    var _a, _b, _c, _d, _e, _f;
    if (disable)
      return;
    if (!inputs2.pointerIsValid(e2))
      return;
    if (e2.button === 2) {
      (_a = callbacks.onRightPointShape) == null ? void 0 : _a.call(callbacks, inputs2.pointerDown(e2, id), e2);
      return;
    }
    if (e2.button !== 0)
      return;
    const info = inputs2.pointerDown(e2, id);
    e2.stopPropagation();
    (_b = e2.currentTarget) == null ? void 0 : _b.setPointerCapture(e2.pointerId);
    if (rSelectionBounds.current && Utils.pointInBounds(info.point, rSelectionBounds.current) && !rPageState.current.selectedIds.includes(id)) {
      (_c = callbacks.onPointBounds) == null ? void 0 : _c.call(callbacks, inputs2.pointerDown(e2, "bounds"), e2);
      (_d = callbacks.onPointShape) == null ? void 0 : _d.call(callbacks, info, e2);
      return;
    }
    (_e = callbacks.onPointShape) == null ? void 0 : _e.call(callbacks, info, e2);
    (_f = callbacks.onPointerDown) == null ? void 0 : _f.call(callbacks, info, e2);
  }, [inputs2, callbacks, id, disable]);
  const onPointerUp = useCallback2((e2) => {
    var _a, _b, _c, _d;
    if (e2.button !== 0)
      return;
    if (!inputs2.pointerIsValid(e2))
      return;
    if (disable)
      return;
    e2.stopPropagation();
    const isDoubleClick = inputs2.isDoubleClick();
    const info = inputs2.pointerUp(e2, id);
    if (e2.currentTarget.hasPointerCapture(e2.pointerId)) {
      (_a = e2.currentTarget) == null ? void 0 : _a.releasePointerCapture(e2.pointerId);
    }
    if (isDoubleClick && !(info.altKey || info.metaKey)) {
      (_b = callbacks.onDoubleClickShape) == null ? void 0 : _b.call(callbacks, info, e2);
    }
    (_c = callbacks.onReleaseShape) == null ? void 0 : _c.call(callbacks, info, e2);
    (_d = callbacks.onPointerUp) == null ? void 0 : _d.call(callbacks, info, e2);
  }, [inputs2, callbacks, id, disable]);
  const onPointerMove = useCallback2((e2) => {
    var _a, _b;
    if (!inputs2.pointerIsValid(e2))
      return;
    if (disable)
      return;
    e2.stopPropagation();
    if (inputs2.pointer && e2.pointerId !== inputs2.pointer.pointerId)
      return;
    const info = inputs2.pointerMove(e2, id);
    if (e2.currentTarget.hasPointerCapture(e2.pointerId)) {
      (_a = callbacks.onDragShape) == null ? void 0 : _a.call(callbacks, info, e2);
    }
    (_b = callbacks.onPointerMove) == null ? void 0 : _b.call(callbacks, info, e2);
  }, [inputs2, callbacks, id, disable]);
  const onPointerEnter = useCallback2((e2) => {
    var _a;
    if (!inputs2.pointerIsValid(e2))
      return;
    if (disable)
      return;
    const info = inputs2.pointerEnter(e2, id);
    (_a = callbacks.onHoverShape) == null ? void 0 : _a.call(callbacks, info, e2);
  }, [inputs2, callbacks, id, disable]);
  const onPointerLeave = useCallback2((e2) => {
    var _a;
    if (disable)
      return;
    if (!inputs2.pointerIsValid(e2))
      return;
    const info = inputs2.pointerEnter(e2, id);
    (_a = callbacks.onUnhoverShape) == null ? void 0 : _a.call(callbacks, info, e2);
  }, [inputs2, callbacks, id, disable]);
  return {
    onPointerDown,
    onPointerUp,
    onPointerEnter,
    onPointerMove,
    onPointerLeave
  };
}

// src/hooks/useShapeTree.tsx
import {
  useRef as useRef2
} from "react";
function addToShapeTree(shape, branch, shapes, pageState, meta) {
  const node = {
    shape,
    meta,
    isCurrentParent: pageState.currentParentId === shape.id,
    isEditing: pageState.editingId === shape.id,
    isBinding: pageState.bindingTargetId === shape.id,
    isSelected: pageState.selectedIds.includes(shape.id),
    isHovered: pageState.hoveredId === shape.id || shape.children !== void 0 && (pageState.hoveredId && shape.children.includes(pageState.hoveredId) || shape.children.some((childId) => pageState.selectedIds.includes(childId)))
  };
  branch.push(node);
  if (shape.children) {
    node.children = [];
    shape.children.map((id) => shapes[id]).sort((a, b2) => a.childIndex - b2.childIndex).forEach((childShape) => addToShapeTree(childShape, node.children, shapes, pageState, meta));
  }
}
function shapeIsInViewport(bounds, viewport) {
  return Utils.boundsContain(viewport, bounds) || Utils.boundsCollide(viewport, bounds);
}
function getShapeUtils(shape, shapeUtils) {
  return shapeUtils[shape.type];
}
function useShapeTree(page, pageState, shapeUtils, size, meta, onRenderCountChange) {
  const rTimeout = useRef2();
  const rPreviousCount = useRef2(0);
  const rShapesIdsToRender = useRef2(new Set());
  const rShapesToRender = useRef2(new Set());
  const { selectedIds, camera } = pageState;
  const [minX, minY] = e.sub(e.div([0, 0], camera.zoom), camera.point);
  const [maxX, maxY] = e.sub(e.div(size, camera.zoom), camera.point);
  const viewport = {
    minX,
    minY,
    maxX,
    maxY,
    height: maxX - minX,
    width: maxY - minY
  };
  const shapesToRender = rShapesToRender.current;
  const shapesIdsToRender = rShapesIdsToRender.current;
  shapesToRender.clear();
  shapesIdsToRender.clear();
  Object.values(page.shapes).filter((shape) => getShapeUtils(shape, shapeUtils).isStateful || selectedIds.includes(shape.id) || shapeIsInViewport(shapeUtils[shape.type].getBounds(shape), viewport)).sort((a, b2) => a.childIndex - b2.childIndex).forEach((shape) => {
    if (shape.parentId === page.id) {
      shapesIdsToRender.add(shape.id);
      shapesToRender.add(shape);
      return;
    }
    shapesIdsToRender.add(shape.parentId);
    shapesToRender.add(page.shapes[shape.parentId]);
  });
  if (shapesToRender.size !== rPreviousCount.current) {
    if (rTimeout.current) {
      clearTimeout(rTimeout.current);
    }
    rTimeout.current = requestAnimationFrame(() => {
      onRenderCountChange == null ? void 0 : onRenderCountChange(Array.from(shapesIdsToRender.values()));
    });
    rPreviousCount.current = shapesToRender.size;
  }
  const bindingTargetId = pageState.bindingId ? page.bindings[pageState.bindingId].toId : void 0;
  const tree = [];
  const info = __spreadProps(__spreadValues({}, pageState), { bindingTargetId });
  shapesToRender.forEach((shape) => addToShapeTree(shape, tree, page.shapes, info, meta));
  return tree;
}

// src/hooks/useStyle.tsx
import {
  useLayoutEffect,
  useMemo
} from "react";
var styles = new Map();
function makeCssTheme(prefix, theme) {
  return Object.keys(theme).reduce((acc, key) => {
    const value = theme[key];
    if (value) {
      return acc + `${`--${prefix}-${key}`}: ${value};
`;
    }
    return acc;
  }, "");
}
function useTheme(prefix, theme, selector = ":root") {
  useLayoutEffect(() => {
    const style = document.createElement("style");
    const cssTheme = makeCssTheme(prefix, theme);
    style.setAttribute("id", `${prefix}-theme`);
    style.setAttribute("data-selector", selector);
    style.innerHTML = `
        ${selector} {
          ${cssTheme}
        }
      `;
    document.head.appendChild(style);
    return () => {
      if (style && document.head.contains(style)) {
        document.head.removeChild(style);
      }
    };
  }, [prefix, theme, selector]);
}
function useStyle(uid, rules) {
  useLayoutEffect(() => {
    if (styles.get(uid)) {
      return () => void 0;
    }
    const style = document.createElement("style");
    style.innerHTML = rules;
    style.setAttribute("id", uid);
    document.head.appendChild(style);
    styles.set(uid, style);
    return () => {
      if (style && document.head.contains(style)) {
        document.head.removeChild(style);
        styles.delete(uid);
      }
    };
  }, [uid, rules]);
}
var css = (strings, ...args) => strings.reduce((acc, string, index) => acc + string + (index < args.length ? args[index] : ""), "");
var defaultTheme = {
  accent: "rgb(255, 0, 0)",
  brushFill: "rgba(0,0,0,.05)",
  brushStroke: "rgba(0,0,0,.25)",
  selectStroke: "rgb(66, 133, 244)",
  selectFill: "rgba(65, 132, 244, 0.04)",
  background: "rgb(248, 249, 250)",
  foreground: "rgb(51, 51, 51)"
};
var tlcss = css`
  @font-face {
    font-family: 'Recursive';
    font-style: normal;
    font-weight: 500;
    font-display: swap;
    src: url(https://fonts.gstatic.com/s/recursive/v23/8vI-7wMr0mhh-RQChyHEH06TlXhq_gukbYrFMk1QuAIcyEwG_X-dpEfaE5YaERmK-CImKsvxvU-MXGX2fSqasNfUlTGZnI14ZeY.woff2)
      format('woff2');
    unicode-range: U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC,
      U+2000-206F, U+2074, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD;
  }

  @font-face {
    font-family: 'Recursive';
    font-style: normal;
    font-weight: 700;
    font-display: swap;
    src: url(https://fonts.gstatic.com/s/recursive/v23/8vI-7wMr0mhh-RQChyHEH06TlXhq_gukbYrFMk1QuAIcyEwG_X-dpEfaE5YaERmK-CImKsvxvU-MXGX2fSqasNfUlTGZnI14ZeY.woff2)
      format('woff2');
    unicode-range: U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC,
      U+2000-206F, U+2074, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD;
  }

  @font-face {
    font-family: 'Recursive Mono';
    font-style: normal;
    font-weight: 420;
    font-display: swap;
    src: url(https://fonts.gstatic.com/s/recursive/v23/8vI-7wMr0mhh-RQChyHEH06TlXhq_gukbYrFMk1QuAIcyEwG_X-dpEfaE5YaERmK-CImqvTxvU-MXGX2fSqasNfUlTGZnI14ZeY.woff2)
      format('woff2');
    unicode-range: U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC,
      U+2000-206F, U+2074, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD;
  }

  .tl-container {
    --tl-zoom: 1;
    --tl-scale: calc(1 / var(--tl-zoom));
    --tl-padding: calc(64px * max(1, var(--tl-scale)));
    position: relative;
    top: 0px;
    left: 0px;
    width: 100%;
    height: 100%;
    max-width: 100%;
    max-height: 100%;
    box-sizing: border-box;
    padding: 0px;
    margin: 0px;
    z-index: 100;
    overflow: hidden;
    touch-action: none;
    overscroll-behavior: none;
    background-color: var(--tl-background);
  }

  .tl-container * {
    box-sizing: border-box;
  }

  .tl-overlay {
    position: absolute;
    width: 100%;
    height: 100%;
    touch-action: none;
    pointer-events: none;
  }

  .tl-snap-line {
    stroke: var(--tl-accent);
    stroke-width: calc(1px * var(--tl-scale));
  }

  .tl-snap-point {
    stroke: var(--tl-accent);
    stroke-width: calc(1px * var(--tl-scale));
  }

  .tl-canvas {
    position: absolute;
    width: 100%;
    height: 100%;
    touch-action: none;
    pointer-events: all;
    overflow: clip;
  }

  .tl-layer {
    position: absolute;
    top: 0px;
    left: 0px;
    height: 0px;
    width: 0px;
    contain: layout style size;
  }

  .tl-absolute {
    position: absolute;
    top: 0px;
    left: 0px;
    transform-origin: center center;
    contain: layout style size;
  }

  .tl-positioned {
    position: absolute;
    top: 0px;
    left: 0px;
    transform-origin: center center;
    pointer-events: none;
    display: flex;
    align-items: center;
    justify-content: center;
    overflow: hidden;
    contain: layout style size;
  }

  .tl-positioned-svg {
    width: 100%;
    height: 100%;
    overflow: hidden;
    contain: layout style size;
  }

  .tl-positioned-div {
    position: relative;
    width: 100%;
    height: 100%;
    overflow: hidden;
    padding: var(--tl-padding);
    overflow: hidden;
    contain: layout style size;
  }

  .tl-counter-scaled {
    transform: scale(var(--tl-scale));
  }

  .tl-dashed {
    stroke-dasharray: calc(2px * var(--tl-scale)), calc(2px * var(--tl-scale));
  }

  .tl-transparent {
    fill: transparent;
    stroke: transparent;
  }

  .tl-cursor-ns {
    cursor: ns-resize;
  }

  .tl-cursor-ew {
    cursor: ew-resize;
  }

  .tl-cursor-nesw {
    cursor: nesw-resize;
  }

  .tl-cursor-nwse {
    cursor: nwse-resize;
  }

  .tl-corner-handle {
    stroke: var(--tl-selectStroke);
    fill: var(--tl-background);
    stroke-width: calc(1.5px * var(--tl-scale));
  }

  .tl-rotate-handle {
    stroke: var(--tl-selectStroke);
    fill: var(--tl-background);
    stroke-width: calc(1.5px * var(--tl-scale));
    cursor: grab;
  }

  .tl-binding {
    fill: var(--tl-selectFill);
    stroke: var(--tl-selectStroke);
    stroke-width: calc(1px * var(--tl-scale));
    pointer-events: none;
  }

  .tl-user {
    left: -4px;
    top: -4px;
    height: 8px;
    width: 8px;
    border-radius: 100%;
    pointer-events: none;
  }

  .tl-indicator {
    fill: transparent;
    stroke-width: calc(1.5px * var(--tl-scale));
    pointer-events: none;
  }

  .tl-user-indicator-bounds {
    border-style: solid;
    border-width: calc(1px * var(--tl-scale));
  }

  .tl-selected {
    stroke: var(--tl-selectStroke);
  }

  .tl-hovered {
    stroke: var(--tl-selectStroke);
  }

  .tl-hover-target {
    pointer-events: all;
  }

  .tl-hover-button {
    stroke-width: calc(1.5px * var(--tl-scale));
    stroke: var(--tl-selectStroke);
  }

  .tl-hover-target > .tl-hover-button {
  }

  .tl-hover-target:hover > .tl-hover-button {
  }

  .tl-hover-target:active > .tl-hover-button {
  }

  .tl-hover-target:hover {
  }

  .tl-clone-button {
    r: calc(8px * var(--tl-scale));
    pointer-events: all;
    cursor: pointer;
    fill: transparent;
  }

  .tl-clone-button:hover {
    fill: var(--tl-selectStroke);
  }

  .tl-bounds {
    pointer-events: none;
    contain: layout style size;
  }

  .tl-bounds-bg {
    stroke: none;
    fill: var(--tl-selectFill);
    pointer-events: all;
    contain: layout style size;
  }

  .tl-bounds-center {
    fill: transparent;
    stroke: var(--tl-selectStroke);
    stroke-width: calc(1.5px * var(--tl-scale));
  }

  .tl-brush {
    fill: var(--tl-brushFill);
    stroke: var(--tl-brushStroke);
    stroke-width: calc(1px * var(--tl-scale));
    pointer-events: none;
    contain: layout style size;
  }

  .tl-dot {
    fill: var(--tl-background);
    stroke: var(--tl-foreground);
    stroke-width: 2px;
  }

  .tl-handle {
    pointer-events: all;
  }

  .tl-handle:hover .tl-handle-bg {
    fill: var(--tl-selectFill);
  }

  .tl-handle:hover .tl-handle-bg > * {
    stroke: var(--tl-selectFill);
  }

  .tl-handle:active .tl-handle-bg {
    fill: var(--tl-selectFill);
  }

  .tl-handle:active .tl-handle-bg > * {
    stroke: var(--tl-selectFill);
  }

  .tl-handle {
    fill: var(--tl-background);
    stroke: var(--tl-selectStroke);
    stroke-width: 1.5px;
  }

  .tl-handle-bg {
    fill: transparent;
    stroke: none;
    pointer-events: all;
    r: calc(16px / max(1, var(--tl-zoom)));
  }

  .tl-binding-indicator {
    stroke-width: calc(3px * var(--tl-scale));
    fill: var(--tl-selectFill);
    stroke: var(--tl-selected);
  }

  .tl-centered-g {
    transform: translate(var(--tl-padding), var(--tl-padding));
  }

  .tl-current-parent > *[data-shy='true'] {
    opacity: 1;
  }

  .tl-binding {
    fill: none;
    stroke: var(--tl-selectStroke);
    stroke-width: calc(2px * var(--tl-scale));
  }
`;
function useTLTheme(theme, selector) {
  const tltheme = useMemo(() => __spreadValues(__spreadValues({}, defaultTheme), theme), [theme]);
  useTheme("tl", tltheme, selector);
  useStyle("tl-canvas", tlcss);
}

// src/hooks/useBoundsHandleEvents.tsx
import {
  useCallback as useCallback3
} from "react";
function useBoundsHandleEvents(id) {
  const { callbacks, inputs: inputs2 } = useTLContext();
  const onPointerDown = useCallback3((e2) => {
    var _a, _b, _c;
    if (e2.button !== 0)
      return;
    if (!inputs2.pointerIsValid(e2))
      return;
    e2.stopPropagation();
    (_a = e2.currentTarget) == null ? void 0 : _a.setPointerCapture(e2.pointerId);
    const info = inputs2.pointerDown(e2, id);
    (_b = callbacks.onPointBoundsHandle) == null ? void 0 : _b.call(callbacks, info, e2);
    (_c = callbacks.onPointerDown) == null ? void 0 : _c.call(callbacks, info, e2);
  }, [inputs2, callbacks, id]);
  const onPointerUp = useCallback3((e2) => {
    var _a, _b, _c, _d;
    if (e2.button !== 0)
      return;
    if (!inputs2.pointerIsValid(e2))
      return;
    e2.stopPropagation();
    const isDoubleClick = inputs2.isDoubleClick();
    const info = inputs2.pointerUp(e2, id);
    if (e2.currentTarget.hasPointerCapture(e2.pointerId)) {
      (_a = e2.currentTarget) == null ? void 0 : _a.releasePointerCapture(e2.pointerId);
    }
    if (isDoubleClick && !(info.altKey || info.metaKey)) {
      (_b = callbacks.onDoubleClickBoundsHandle) == null ? void 0 : _b.call(callbacks, info, e2);
    }
    (_c = callbacks.onReleaseBoundsHandle) == null ? void 0 : _c.call(callbacks, info, e2);
    (_d = callbacks.onPointerUp) == null ? void 0 : _d.call(callbacks, info, e2);
  }, [inputs2, callbacks, id]);
  const onPointerMove = useCallback3((e2) => {
    var _a, _b;
    if (!inputs2.pointerIsValid(e2))
      return;
    if (e2.currentTarget.hasPointerCapture(e2.pointerId)) {
      (_a = callbacks.onDragBoundsHandle) == null ? void 0 : _a.call(callbacks, inputs2.pointerMove(e2, id), e2);
    }
    const info = inputs2.pointerMove(e2, id);
    (_b = callbacks.onPointerMove) == null ? void 0 : _b.call(callbacks, info, e2);
  }, [inputs2, callbacks, id]);
  const onPointerEnter = useCallback3((e2) => {
    var _a;
    if (!inputs2.pointerIsValid(e2))
      return;
    (_a = callbacks.onHoverBoundsHandle) == null ? void 0 : _a.call(callbacks, inputs2.pointerEnter(e2, id), e2);
  }, [inputs2, callbacks, id]);
  const onPointerLeave = useCallback3((e2) => {
    var _a;
    if (!inputs2.pointerIsValid(e2))
      return;
    (_a = callbacks.onUnhoverBoundsHandle) == null ? void 0 : _a.call(callbacks, inputs2.pointerEnter(e2, id), e2);
  }, [inputs2, callbacks, id]);
  return {
    onPointerDown,
    onPointerUp,
    onPointerEnter,
    onPointerMove,
    onPointerLeave
  };
}

// src/hooks/useCameraCss.tsx
import {
  useLayoutEffect as useLayoutEffect2,
  useRef as useRef3
} from "react";
function useCameraCss(layerRef, containerRef, pageState) {
  const rZoom = useRef3(pageState.camera.zoom);
  const rPoint = useRef3(pageState.camera.point);
  useLayoutEffect2(() => {
    const { zoom, point } = pageState.camera;
    const didZoom = zoom !== rZoom.current;
    const didPan = point !== rPoint.current;
    rZoom.current = zoom;
    rPoint.current = point;
    if (didZoom || didPan) {
      const layer = layerRef.current;
      const container = containerRef.current;
      if (didZoom) {
        if (container) {
          container.style.setProperty("--tl-zoom", zoom.toString());
        }
      }
      if (layer) {
        layer.style.setProperty("transform", `scale(${zoom}) translateX(${point[0]}px) translateY(${point[1]}px)`);
      }
    }
  }, [pageState.camera]);
}

// src/hooks/useSelection.tsx
import {
  useRef as useRef4
} from "react";
function canvasToScreen(point, camera) {
  return [(point[0] + camera.point[0]) * camera.zoom, (point[1] + camera.point[1]) * camera.zoom];
}
function useSelection(page, pageState, shapeUtils) {
  const { rSelectionBounds } = useTLContext();
  const { selectedIds } = pageState;
  const rPrevBounds = useRef4();
  let bounds = void 0;
  let rotation = 0;
  let isLocked = false;
  let isLinked = false;
  if (selectedIds.length === 1) {
    const id = selectedIds[0];
    const shape = page.shapes[id];
    rotation = shape.rotation || 0;
    isLocked = shape.isLocked || false;
    bounds = shapeUtils[shape.type].getBounds(shape);
  } else if (selectedIds.length > 1) {
    const selectedShapes = selectedIds.map((id) => page.shapes[id]);
    rotation = 0;
    isLocked = selectedShapes.every((shape) => shape.isLocked);
    bounds = selectedShapes.reduce((acc, shape, i) => {
      if (i === 0) {
        return shapeUtils[shape.type].getRotatedBounds(shape);
      }
      return utils_default.getExpandedBounds(acc, shapeUtils[shape.type].getRotatedBounds(shape));
    }, {});
  }
  if (bounds) {
    const [minX, minY] = canvasToScreen([bounds.minX, bounds.minY], pageState.camera);
    const [maxX, maxY] = canvasToScreen([bounds.maxX, bounds.maxY], pageState.camera);
    isLinked = !!Object.values(page.bindings).find((binding) => selectedIds.includes(binding.toId) || selectedIds.includes(binding.fromId));
    rSelectionBounds.current = {
      minX,
      minY,
      maxX,
      maxY,
      width: maxX - minX,
      height: maxY - minY
    };
  } else {
    rSelectionBounds.current = null;
  }
  const prevBounds = rPrevBounds.current;
  if (!prevBounds || !bounds) {
    rPrevBounds.current = bounds;
  } else if (bounds) {
    if (prevBounds.minX === bounds.minX && prevBounds.minY === bounds.minY && prevBounds.maxX === bounds.maxX && prevBounds.maxY === bounds.maxY) {
      bounds = rPrevBounds.current;
    }
  }
  return { bounds, rotation, isLocked, isLinked };
}

// src/hooks/useHandleEvents.tsx
import {
  useCallback as useCallback4
} from "react";
function useHandleEvents(id) {
  const { inputs: inputs2, callbacks } = useTLContext();
  const onPointerDown = useCallback4((e2) => {
    var _a, _b, _c;
    if (e2.button !== 0)
      return;
    if (!inputs2.pointerIsValid(e2))
      return;
    e2.stopPropagation();
    (_a = e2.currentTarget) == null ? void 0 : _a.setPointerCapture(e2.pointerId);
    const info = inputs2.pointerDown(e2, id);
    (_b = callbacks.onPointHandle) == null ? void 0 : _b.call(callbacks, info, e2);
    (_c = callbacks.onPointerDown) == null ? void 0 : _c.call(callbacks, info, e2);
  }, [inputs2, callbacks, id]);
  const onPointerUp = useCallback4((e2) => {
    var _a, _b, _c, _d;
    if (e2.button !== 0)
      return;
    if (!inputs2.pointerIsValid(e2))
      return;
    e2.stopPropagation();
    const isDoubleClick = inputs2.isDoubleClick();
    const info = inputs2.pointerUp(e2, id);
    if (e2.currentTarget.hasPointerCapture(e2.pointerId)) {
      (_a = e2.currentTarget) == null ? void 0 : _a.releasePointerCapture(e2.pointerId);
      if (isDoubleClick && !(info.altKey || info.metaKey)) {
        (_b = callbacks.onDoubleClickHandle) == null ? void 0 : _b.call(callbacks, info, e2);
      }
      (_c = callbacks.onReleaseHandle) == null ? void 0 : _c.call(callbacks, info, e2);
    }
    (_d = callbacks.onPointerUp) == null ? void 0 : _d.call(callbacks, info, e2);
  }, [inputs2, callbacks]);
  const onPointerMove = useCallback4((e2) => {
    var _a, _b;
    if (!inputs2.pointerIsValid(e2))
      return;
    if (e2.currentTarget.hasPointerCapture(e2.pointerId)) {
      const info2 = inputs2.pointerMove(e2, id);
      (_a = callbacks.onDragHandle) == null ? void 0 : _a.call(callbacks, info2, e2);
    }
    const info = inputs2.pointerMove(e2, id);
    (_b = callbacks.onPointerMove) == null ? void 0 : _b.call(callbacks, info, e2);
  }, [inputs2, callbacks, id]);
  const onPointerEnter = useCallback4((e2) => {
    var _a;
    if (!inputs2.pointerIsValid(e2))
      return;
    const info = inputs2.pointerEnter(e2, id);
    (_a = callbacks.onHoverHandle) == null ? void 0 : _a.call(callbacks, info, e2);
  }, [inputs2, callbacks, id]);
  const onPointerLeave = useCallback4((e2) => {
    var _a;
    if (!inputs2.pointerIsValid(e2))
      return;
    const info = inputs2.pointerEnter(e2, id);
    (_a = callbacks.onUnhoverHandle) == null ? void 0 : _a.call(callbacks, info, e2);
  }, [inputs2, callbacks, id]);
  return {
    onPointerDown,
    onPointerUp,
    onPointerEnter,
    onPointerMove,
    onPointerLeave
  };
}

// src/hooks/usePreventNavigation.tsx
import {
  useEffect as useEffect3
} from "react";
function usePreventNavigation(rCanvas, width) {
  useEffect3(() => {
    const preventGestureNavigation = (event) => {
      event.preventDefault();
    };
    const preventNavigation = (event) => {
      const touchXPosition = event.touches[0].pageX;
      const touchXRadius = event.touches[0].radiusX || 0;
      if (touchXPosition - touchXRadius < 10 || touchXPosition + touchXRadius > width - 10) {
        event.preventDefault();
      }
    };
    const elm = rCanvas.current;
    if (!elm)
      return () => void 0;
    elm.addEventListener("touchstart", preventGestureNavigation);
    elm.addEventListener("gestureend", preventGestureNavigation);
    elm.addEventListener("gesturechange", preventGestureNavigation);
    elm.addEventListener("gesturestart", preventGestureNavigation);
    elm.addEventListener("touchstart", preventNavigation);
    return () => {
      if (elm) {
        elm.removeEventListener("touchstart", preventGestureNavigation);
        elm.removeEventListener("gestureend", preventGestureNavigation);
        elm.removeEventListener("gesturechange", preventGestureNavigation);
        elm.removeEventListener("gesturestart", preventGestureNavigation);
        elm.removeEventListener("touchstart", preventNavigation);
      }
    };
  }, [rCanvas, width]);
}

// src/hooks/useBoundsEvents.tsx
import {
  useCallback as useCallback5
} from "react";
function useBoundsEvents() {
  const { callbacks, inputs: inputs2 } = useTLContext();
  const onPointerDown = useCallback5((e2) => {
    var _a, _b, _c;
    if (e2.button !== 0)
      return;
    if (!inputs2.pointerIsValid(e2))
      return;
    e2.stopPropagation();
    (_a = e2.currentTarget) == null ? void 0 : _a.setPointerCapture(e2.pointerId);
    const info = inputs2.pointerDown(e2, "bounds");
    (_b = callbacks.onPointBounds) == null ? void 0 : _b.call(callbacks, info, e2);
    (_c = callbacks.onPointerDown) == null ? void 0 : _c.call(callbacks, info, e2);
  }, [callbacks, inputs2]);
  const onPointerUp = useCallback5((e2) => {
    var _a, _b, _c, _d;
    if (e2.button !== 0)
      return;
    if (!inputs2.pointerIsValid(e2))
      return;
    e2.stopPropagation();
    const isDoubleClick = inputs2.isDoubleClick();
    const info = inputs2.pointerUp(e2, "bounds");
    if (e2.currentTarget.hasPointerCapture(e2.pointerId)) {
      (_a = e2.currentTarget) == null ? void 0 : _a.releasePointerCapture(e2.pointerId);
    }
    if (isDoubleClick && !(info.altKey || info.metaKey)) {
      (_b = callbacks.onDoubleClickBounds) == null ? void 0 : _b.call(callbacks, info, e2);
    }
    (_c = callbacks.onReleaseBounds) == null ? void 0 : _c.call(callbacks, info, e2);
    (_d = callbacks.onPointerUp) == null ? void 0 : _d.call(callbacks, info, e2);
  }, [callbacks, inputs2]);
  const onPointerMove = useCallback5((e2) => {
    var _a, _b;
    if (!inputs2.pointerIsValid(e2))
      return;
    if (e2.currentTarget.hasPointerCapture(e2.pointerId)) {
      (_a = callbacks.onDragBounds) == null ? void 0 : _a.call(callbacks, inputs2.pointerMove(e2, "bounds"), e2);
    }
    const info = inputs2.pointerMove(e2, "bounds");
    (_b = callbacks.onPointerMove) == null ? void 0 : _b.call(callbacks, info, e2);
  }, [callbacks, inputs2]);
  const onPointerEnter = useCallback5((e2) => {
    var _a;
    if (!inputs2.pointerIsValid(e2))
      return;
    (_a = callbacks.onHoverBounds) == null ? void 0 : _a.call(callbacks, inputs2.pointerEnter(e2, "bounds"), e2);
  }, [callbacks, inputs2]);
  const onPointerLeave = useCallback5((e2) => {
    var _a;
    if (!inputs2.pointerIsValid(e2))
      return;
    (_a = callbacks.onUnhoverBounds) == null ? void 0 : _a.call(callbacks, inputs2.pointerEnter(e2, "bounds"), e2);
  }, [callbacks, inputs2]);
  return {
    onPointerDown,
    onPointerUp,
    onPointerEnter,
    onPointerMove,
    onPointerLeave
  };
}

// src/hooks/usePosition.ts
import {
  useLayoutEffect as useLayoutEffect3,
  useRef as useRef5
} from "react";
function usePosition(bounds, rotation = 0) {
  const rBounds = useRef5(null);
  useLayoutEffect3(() => {
    const elm = rBounds.current;
    const transform = `
    translate(
      calc(${bounds.minX}px - var(--tl-padding)),
      calc(${bounds.minY}px - var(--tl-padding))
    )
    rotate(${rotation + (bounds.rotation || 0)}rad)`;
    elm.style.setProperty("transform", transform);
    elm.style.setProperty("width", `calc(${Math.floor(bounds.width)}px + (var(--tl-padding) * 2))`);
    elm.style.setProperty("height", `calc(${Math.floor(bounds.height)}px + (var(--tl-padding) * 2))`);
  }, [bounds, rotation]);
  return rBounds;
}

// src/hooks/useKeyEvents.ts
import {
  useEffect as useEffect4
} from "react";
function useKeyEvents() {
  const { inputs: inputs2, callbacks } = useTLContext();
  useEffect4(() => {
    const handleKeyDown = (e2) => {
      var _a;
      (_a = callbacks.onKeyDown) == null ? void 0 : _a.call(callbacks, e2.key, inputs2.keydown(e2), e2);
    };
    const handleKeyUp = (e2) => {
      var _a;
      inputs2.keyup(e2);
      (_a = callbacks.onKeyUp) == null ? void 0 : _a.call(callbacks, e2.key, inputs2.keyup(e2), e2);
    };
    window.addEventListener("keydown", handleKeyDown);
    window.addEventListener("keyup", handleKeyUp);
    return () => {
      window.removeEventListener("keydown", handleKeyDown);
      window.removeEventListener("keyup", handleKeyUp);
    };
  }, [inputs2, callbacks]);
}

// src/components/error-fallback/error-fallback.tsx
import {
  memo,
  useEffect as useEffect5
} from "react";
var ErrorFallback = memo(({ error, resetErrorBoundary }) => {
  const { callbacks } = useTLContext();
  useEffect5(() => {
    var _a;
    (_a = callbacks.onError) == null ? void 0 : _a.call(callbacks, error);
  }, [error, resetErrorBoundary, callbacks]);
  return null;
});

// src/components/error-boundary/error-boundary.tsx
import {
  Component,
  createElement,
  isValidElement
} from "react";
var changedArray = (a = [], b2 = []) => a.length !== b2.length || a.some((item, index) => !Object.is(item, b2[index]));
var initialState = { error: null };
var ErrorBoundary = class extends Component {
  constructor() {
    super(...arguments);
    this.state = initialState;
    this.updatedWithError = false;
    this.resetErrorBoundary = (...args) => {
      var _a, _b;
      (_b = (_a = this.props).onReset) == null ? void 0 : _b.call(_a, ...args);
      this.reset();
    };
  }
  static getDerivedStateFromError(error) {
    return { error };
  }
  reset() {
    this.updatedWithError = false;
    this.setState(initialState);
  }
  componentDidCatch(error, info) {
    var _a, _b;
    (_b = (_a = this.props).onError) == null ? void 0 : _b.call(_a, error, info);
  }
  componentDidMount() {
    const { error } = this.state;
    if (error !== null) {
      this.updatedWithError = true;
    }
  }
  componentDidUpdate(prevProps) {
    var _a, _b;
    const { error } = this.state;
    const { resetKeys } = this.props;
    if (error !== null && !this.updatedWithError) {
      this.updatedWithError = true;
      return;
    }
    if (error !== null && changedArray(prevProps.resetKeys, resetKeys)) {
      (_b = (_a = this.props).onResetKeysChange) == null ? void 0 : _b.call(_a, prevProps.resetKeys, resetKeys);
      this.reset();
    }
  }
  render() {
    const { error } = this.state;
    const { fallbackRender, FallbackComponent, fallback } = this.props;
    if (error !== null) {
      const props = {
        error,
        resetErrorBoundary: this.resetErrorBoundary
      };
      if (isValidElement(fallback)) {
        return fallback;
      } else if (typeof fallbackRender === "function") {
        return fallbackRender(props);
      } else if (FallbackComponent) {
        return /* @__PURE__ */ createElement(FallbackComponent, __spreadValues({}, props));
      } else {
        throw new Error("react-error-boundary requires either a fallback, fallbackRender, or FallbackComponent prop");
      }
    }
    return this.props.children;
  }
};

// src/components/container/container.tsx
import {
  createElement as createElement2,
  memo as memo2
} from "react";
var Container = memo2(({ id, bounds, rotation = 0, className, children }) => {
  const rPositioned = usePosition(bounds, rotation);
  return /* @__PURE__ */ createElement2("div", {
    id,
    ref: rPositioned,
    className: ["tl-positioned", className || ""].join(" ")
  }, children);
});

// src/components/brush/brush.tsx
import {
  createElement as createElement3,
  memo as memo3
} from "react";
var Brush = memo3(({ brush }) => {
  return /* @__PURE__ */ createElement3(Container, {
    bounds: brush,
    rotation: 0
  }, /* @__PURE__ */ createElement3(SVGContainer, null, /* @__PURE__ */ createElement3("rect", {
    className: "tl-brush",
    opacity: 1,
    x: 0,
    y: 0,
    width: brush.width,
    height: brush.height
  })));
});

// src/components/page/page.tsx
import {
  Fragment as Fragment4,
  createElement as createElement20,
  memo as memo17
} from "react";

// src/components/bounds/bounds.tsx
import {
  createElement as createElement12,
  memo as memo9
} from "react";

// src/components/bounds/center-handle.tsx
import {
  createElement as createElement4,
  memo as memo4
} from "react";
var CenterHandle = memo4(({ bounds, isLocked, isHidden }) => {
  return /* @__PURE__ */ createElement4("rect", {
    className: isLocked ? "tl-bounds-center tl-dashed" : "tl-bounds-center",
    x: -1,
    y: -1,
    width: bounds.width + 2,
    height: bounds.height + 2,
    opacity: isHidden ? 0 : 1,
    pointerEvents: "none"
  });
});

// src/components/bounds/rotate-handle.tsx
import {
  createElement as createElement5,
  memo as memo5
} from "react";
var RotateHandle = memo5(({ bounds, targetSize, size, isHidden }) => {
  const events = useBoundsHandleEvents("rotate");
  return /* @__PURE__ */ createElement5("g", {
    cursor: "grab",
    opacity: isHidden ? 0 : 1
  }, /* @__PURE__ */ createElement5("circle", __spreadValues({
    className: "tl-transparent",
    cx: bounds.width / 2,
    cy: size * -2,
    r: targetSize,
    pointerEvents: isHidden ? "none" : "all"
  }, events)), /* @__PURE__ */ createElement5("circle", {
    className: "tl-rotate-handle",
    cx: bounds.width / 2,
    cy: size * -2,
    r: size / 2,
    pointerEvents: "none"
  }));
});

// src/components/bounds/corner-handle.tsx
import {
  createElement as createElement6,
  memo as memo6
} from "react";
var cornerBgClassnames = {
  [TLBoundsCorner.TopLeft]: "tl-cursor-nwse",
  [TLBoundsCorner.TopRight]: "tl-cursor-nesw",
  [TLBoundsCorner.BottomRight]: "tl-cursor-nwse",
  [TLBoundsCorner.BottomLeft]: "tl-cursor-nesw"
};
var CornerHandle = memo6(({ size, targetSize, isHidden, corner, bounds }) => {
  const events = useBoundsHandleEvents(corner);
  const isTop = corner === TLBoundsCorner.TopLeft || corner === TLBoundsCorner.TopRight;
  const isLeft = corner === TLBoundsCorner.TopLeft || corner === TLBoundsCorner.BottomLeft;
  return /* @__PURE__ */ createElement6("g", {
    opacity: isHidden ? 0 : 1
  }, /* @__PURE__ */ createElement6("rect", __spreadValues({
    className: "tl-transparent " + (isHidden ? "" : cornerBgClassnames[corner]),
    x: (isLeft ? -1 : bounds.width + 1) - targetSize,
    y: (isTop ? -1 : bounds.height + 1) - targetSize,
    width: targetSize * 2,
    height: targetSize * 2,
    pointerEvents: isHidden ? "none" : "all"
  }, events)), /* @__PURE__ */ createElement6("rect", {
    className: "tl-corner-handle",
    x: (isLeft ? -1 : bounds.width + 1) - size / 2,
    y: (isTop ? -1 : bounds.height + 1) - size / 2,
    width: size,
    height: size,
    pointerEvents: "none"
  }));
});

// src/components/bounds/edge-handle.tsx
import {
  createElement as createElement7,
  memo as memo7
} from "react";
var edgeClassnames = {
  [TLBoundsEdge.Top]: "tl-cursor-ns",
  [TLBoundsEdge.Right]: "tl-cursor-ew",
  [TLBoundsEdge.Bottom]: "tl-cursor-ns",
  [TLBoundsEdge.Left]: "tl-cursor-ew"
};
var EdgeHandle = memo7(({ size, isHidden, bounds, edge }) => {
  const events = useBoundsHandleEvents(edge);
  const isHorizontal = edge === TLBoundsEdge.Top || edge === TLBoundsEdge.Bottom;
  const isFarEdge = edge === TLBoundsEdge.Right || edge === TLBoundsEdge.Bottom;
  const { height, width } = bounds;
  return /* @__PURE__ */ createElement7("rect", __spreadValues({
    pointerEvents: isHidden ? "none" : "all",
    className: "tl-transparent tl-edge-handle " + (isHidden ? "" : edgeClassnames[edge]),
    opacity: isHidden ? 0 : 1,
    x: isHorizontal ? size / 2 : (isFarEdge ? width + 1 : -1) - size / 2,
    y: isHorizontal ? (isFarEdge ? height + 1 : -1) - size / 2 : size / 2,
    width: isHorizontal ? Math.max(0, width + 1 - size) : size,
    height: isHorizontal ? size : Math.max(0, height + 1 - size)
  }, events));
});

// src/components/bounds/clone-buttons.tsx
import {
  Fragment,
  createElement as createElement9
} from "react";

// src/components/bounds/clone-button.tsx
import {
  createElement as createElement8,
  useCallback as useCallback6
} from "react";
function CloneButton({ bounds, side }) {
  const x = {
    left: -44,
    topLeft: -44,
    bottomLeft: -44,
    right: bounds.width + 44,
    topRight: bounds.width + 44,
    bottomRight: bounds.width + 44,
    top: bounds.width / 2,
    bottom: bounds.width / 2
  }[side];
  const y = {
    left: bounds.height / 2,
    right: bounds.height / 2,
    top: -44,
    topLeft: -44,
    topRight: -44,
    bottom: bounds.height + 44,
    bottomLeft: bounds.height + 44,
    bottomRight: bounds.height + 44
  }[side];
  const { callbacks, inputs: inputs2 } = useTLContext();
  const handleClick = useCallback6((e2) => {
    var _a;
    e2.stopPropagation();
    const info = inputs2.pointerDown(e2, side);
    (_a = callbacks.onShapeClone) == null ? void 0 : _a.call(callbacks, info, e2);
  }, [callbacks.onShapeClone]);
  return /* @__PURE__ */ createElement8("g", {
    className: "tl-hover-target",
    transform: `translate(${x}, ${y})`
  }, /* @__PURE__ */ createElement8("rect", {
    className: "tl-transparent",
    width: 88,
    height: 88,
    x: -44,
    y: -44
  }), /* @__PURE__ */ createElement8("circle", {
    className: "tl-clone-button tl-hover-button",
    onPointerDown: handleClick
  }));
}

// src/components/bounds/clone-buttons.tsx
function CloneButtons({ bounds }) {
  return /* @__PURE__ */ createElement9(Fragment, null, /* @__PURE__ */ createElement9(CloneButton, {
    bounds,
    side: "top"
  }), /* @__PURE__ */ createElement9(CloneButton, {
    bounds,
    side: "right"
  }), /* @__PURE__ */ createElement9(CloneButton, {
    bounds,
    side: "bottom"
  }), /* @__PURE__ */ createElement9(CloneButton, {
    bounds,
    side: "left"
  }), /* @__PURE__ */ createElement9(CloneButton, {
    bounds,
    side: "topLeft"
  }), /* @__PURE__ */ createElement9(CloneButton, {
    bounds,
    side: "topRight"
  }), /* @__PURE__ */ createElement9(CloneButton, {
    bounds,
    side: "bottomLeft"
  }), /* @__PURE__ */ createElement9(CloneButton, {
    bounds,
    side: "bottomRight"
  }));
}

// src/components/svg-container/svg-container.tsx
import {
  createElement as createElement10,
  forwardRef,
  memo as memo8
} from "react";
var SVGContainer = memo8(forwardRef((_a, ref) => {
  var _b = _a, { id, children } = _b, rest = __objRest(_b, ["id", "children"]);
  return /* @__PURE__ */ createElement10("svg", __spreadValues({
    ref,
    className: "tl-positioned-svg"
  }, rest), /* @__PURE__ */ createElement10("g", {
    id,
    className: "tl-centered-g"
  }, children));
}));

// src/components/bounds/link-handle.tsx
import {
  createElement as createElement11
} from "react";
function LinkHandle({ size, bounds, isHidden }) {
  const leftEvents = useBoundsHandleEvents("left");
  const centerEvents = useBoundsHandleEvents("center");
  const rightEvents = useBoundsHandleEvents("right");
  return /* @__PURE__ */ createElement11("g", {
    cursor: "grab",
    transform: `translate(${bounds.width / 2 - size * 4}, ${bounds.height + size * 2})`
  }, /* @__PURE__ */ createElement11("g", {
    className: "tl-transparent",
    pointerEvents: isHidden ? "none" : "all"
  }, /* @__PURE__ */ createElement11("rect", __spreadValues({
    x: 0,
    y: 0,
    width: size * 2,
    height: size * 2
  }, leftEvents)), /* @__PURE__ */ createElement11("rect", __spreadValues({
    x: size * 3,
    y: 0,
    width: size * 2,
    height: size * 2
  }, centerEvents)), /* @__PURE__ */ createElement11("rect", __spreadValues({
    x: size * 6,
    y: 0,
    width: size * 2,
    height: size * 2
  }, rightEvents))), /* @__PURE__ */ createElement11("g", {
    className: "tl-rotate-handle",
    transform: `translate(${size / 2}, ${size / 2})`
  }, /* @__PURE__ */ createElement11("path", {
    d: `M 0,${size / 2} L ${size},${size} ${size},0 Z`,
    pointerEvents: "none",
    opacity: isHidden ? 0 : 1
  }), /* @__PURE__ */ createElement11("path", {
    transform: `translate(${size * 3}, 0)`,
    d: `M 0,0 L ${size},0 ${size / 2},${size} Z`,
    pointerEvents: "none",
    opacity: isHidden ? 0 : 1
  }), /* @__PURE__ */ createElement11("path", {
    transform: `translate(${size * 6}, 0)`,
    d: `M ${size},${size / 2} L 0,0 0,${size} Z`,
    pointerEvents: "none",
    opacity: isHidden ? 0 : 1
  })));
}

// src/components/bounds/bounds.tsx
var Bounds = memo9(({
  zoom,
  bounds,
  viewportWidth,
  rotation,
  isHidden,
  isLocked,
  isLinked,
  showCloneButtons
}) => {
  const targetSize = (viewportWidth < 768 ? 16 : 8) / zoom;
  const size = 8 / zoom;
  const smallDimension = Math.min(bounds.width, bounds.height) * zoom;
  const showRotateHandle = !isHidden && !isLocked && smallDimension > 32;
  const showEdgeHandles = !isHidden && !isLocked && smallDimension > 24;
  const showCornerHandles = !isHidden && !isLocked && smallDimension > 20;
  return /* @__PURE__ */ createElement12(Container, {
    bounds,
    rotation
  }, /* @__PURE__ */ createElement12(SVGContainer, null, /* @__PURE__ */ createElement12(CenterHandle, {
    bounds,
    isLocked,
    isHidden
  }), /* @__PURE__ */ createElement12(EdgeHandle, {
    targetSize,
    size,
    bounds,
    edge: TLBoundsEdge.Top,
    isHidden: !showEdgeHandles
  }), /* @__PURE__ */ createElement12(EdgeHandle, {
    targetSize,
    size,
    bounds,
    edge: TLBoundsEdge.Right,
    isHidden: !showEdgeHandles
  }), /* @__PURE__ */ createElement12(EdgeHandle, {
    targetSize,
    size,
    bounds,
    edge: TLBoundsEdge.Bottom,
    isHidden: !showEdgeHandles
  }), /* @__PURE__ */ createElement12(EdgeHandle, {
    targetSize,
    size,
    bounds,
    edge: TLBoundsEdge.Left,
    isHidden: !showEdgeHandles
  }), /* @__PURE__ */ createElement12(CornerHandle, {
    targetSize,
    size,
    bounds,
    isHidden: isHidden || !showCornerHandles,
    corner: TLBoundsCorner.TopLeft
  }), /* @__PURE__ */ createElement12(CornerHandle, {
    targetSize,
    size,
    bounds,
    isHidden: isHidden || !showCornerHandles,
    corner: TLBoundsCorner.TopRight
  }), /* @__PURE__ */ createElement12(CornerHandle, {
    targetSize,
    size,
    bounds,
    isHidden: isHidden || !showCornerHandles,
    corner: TLBoundsCorner.BottomRight
  }), /* @__PURE__ */ createElement12(CornerHandle, {
    targetSize,
    size,
    bounds,
    isHidden: isHidden || !showCornerHandles,
    corner: TLBoundsCorner.BottomLeft
  }), /* @__PURE__ */ createElement12(RotateHandle, {
    targetSize,
    size,
    bounds,
    isHidden: !showEdgeHandles || !showRotateHandle
  }), showCloneButtons && /* @__PURE__ */ createElement12(CloneButtons, {
    bounds
  }), isLinked && /* @__PURE__ */ createElement12(LinkHandle, {
    targetSize,
    size,
    bounds,
    isHidden: !showEdgeHandles || !showRotateHandle
  })));
});

// src/components/bounds/bounds-bg.tsx
import {
  createElement as createElement13,
  memo as memo10
} from "react";
var BoundsBg = memo10(({ bounds, rotation, isHidden }) => {
  const events = useBoundsEvents();
  return /* @__PURE__ */ createElement13(Container, {
    bounds,
    rotation
  }, /* @__PURE__ */ createElement13(SVGContainer, null, /* @__PURE__ */ createElement13("rect", __spreadValues({
    className: "tl-bounds-bg",
    width: bounds.width,
    height: bounds.height,
    opacity: isHidden ? 0 : 1
  }, events))));
});

// src/components/handles/handles.tsx
import {
  Fragment as Fragment2,
  createElement as createElement15,
  memo as memo12
} from "react";

// src/components/handles/handle.tsx
import {
  createElement as createElement14,
  memo as memo11
} from "react";
var Handle = memo11(({ id, point }) => {
  const events = useHandleEvents(id);
  return /* @__PURE__ */ createElement14(Container, {
    bounds: utils_default.translateBounds({
      minX: 0,
      minY: 0,
      maxX: 0,
      maxY: 0,
      width: 0,
      height: 0
    }, point)
  }, /* @__PURE__ */ createElement14(SVGContainer, null, /* @__PURE__ */ createElement14("g", __spreadValues({
    className: "tl-handle"
  }, events), /* @__PURE__ */ createElement14("circle", {
    className: "tl-handle-bg",
    pointerEvents: "all"
  }), /* @__PURE__ */ createElement14("circle", {
    className: "tl-counter-scaled tl-handle",
    pointerEvents: "none",
    r: 4
  }))));
});

// src/components/handles/handles.tsx
var Handles = memo12(({ shape }) => {
  if (shape.handles === void 0) {
    return null;
  }
  return /* @__PURE__ */ createElement15(Fragment2, null, Object.values(shape.handles).map((handle) => /* @__PURE__ */ createElement15(Handle, {
    key: shape.id + "_" + handle.id,
    id: handle.id,
    point: e.add(handle.point, shape.point)
  })));
});

// src/components/shape/shape-node.tsx
import {
  Fragment as Fragment3,
  createElement as createElement18,
  memo as memo15
} from "react";

// src/components/shape/shape.tsx
import {
  createElement as createElement17,
  memo as memo14
} from "react";

// src/components/shape/rendered-shape.tsx
import {
  createElement as createElement16,
  memo as memo13
} from "react";
var RenderedShape = memo13(({
  shape,
  utils,
  isEditing,
  isBinding,
  isHovered,
  isSelected,
  isCurrentParent,
  onShapeChange,
  onShapeBlur,
  events,
  meta
}) => {
  const ref = utils.getRef(shape);
  return /* @__PURE__ */ createElement16(utils._Component, {
    ref,
    shape,
    isEditing,
    isBinding,
    isHovered,
    isSelected,
    isCurrentParent,
    meta,
    events,
    onShapeChange,
    onShapeBlur
  });
}, (prev, next) => {
  if (prev.isHovered !== next.isHovered || prev.isSelected !== next.isSelected || prev.isEditing !== next.isEditing || prev.isBinding !== next.isBinding || prev.meta !== next.meta || prev.isCurrentParent !== next.isCurrentParent) {
    return false;
  }
  if (next.shape !== prev.shape) {
    return !next.utils.shouldRender(next.shape, prev.shape);
  }
  return true;
});

// src/hooks/useForceUpdate.ts
import {
  useLayoutEffect as useLayoutEffect4,
  useReducer
} from "react";
function useForceUpdate() {
  const forceUpdate = useReducer((s) => s + 1, 0);
  useLayoutEffect4(() => forceUpdate[1](), []);
}

// src/components/shape/shape.tsx
var Shape = memo14(({
  shape,
  utils,
  isEditing,
  isBinding,
  isHovered,
  isSelected,
  isCurrentParent,
  meta
}) => {
  const { callbacks } = useTLContext();
  const bounds = utils.getBounds(shape);
  const events = useShapeEvents(shape.id, isCurrentParent);
  useForceUpdate();
  return /* @__PURE__ */ createElement17(Container, {
    id: shape.id,
    bounds,
    rotation: shape.rotation
  }, /* @__PURE__ */ createElement17(RenderedShape, {
    shape,
    isBinding,
    isCurrentParent,
    isEditing,
    isHovered,
    isSelected,
    utils,
    meta,
    events,
    onShapeChange: callbacks.onShapeChange,
    onShapeBlur: callbacks.onShapeBlur
  }));
});

// src/components/shape/shape-node.tsx
var ShapeNode = memo15(({
  shape,
  utils,
  children,
  isEditing,
  isBinding,
  isHovered,
  isSelected,
  isCurrentParent,
  meta
}) => {
  return /* @__PURE__ */ createElement18(Fragment3, null, /* @__PURE__ */ createElement18(Shape, {
    shape,
    isEditing,
    isBinding,
    isHovered,
    isSelected,
    isCurrentParent,
    utils: utils[shape.type],
    meta
  }), children && children.map((childNode) => /* @__PURE__ */ createElement18(ShapeNode, __spreadValues({
    key: childNode.shape.id,
    utils
  }, childNode))));
});

// src/components/shape-indicator/shape-indicator.tsx
import {
  createElement as createElement19,
  memo as memo16
} from "react";
var ShapeIndicator = memo16(({
  isHovered,
  isSelected,
  shape,
  color,
  meta
}) => {
  const { shapeUtils } = useTLContext();
  const utils = shapeUtils[shape.type];
  const bounds = utils.getBounds(shape);
  const rPositioned = usePosition(bounds, shape.rotation);
  return /* @__PURE__ */ createElement19("div", {
    ref: rPositioned,
    className: "tl-indicator tl-absolute " + (color ? "" : isSelected ? "tl-selected" : "tl-hovered")
  }, /* @__PURE__ */ createElement19("svg", {
    width: "100%",
    height: "100%"
  }, /* @__PURE__ */ createElement19("g", {
    className: "tl-centered-g",
    stroke: color
  }, /* @__PURE__ */ createElement19(utils.Indicator, {
    shape,
    meta,
    isSelected,
    isHovered
  }))));
});

// src/components/page/page.tsx
var Page = memo17(function Page2({
  page,
  pageState,
  hideBounds,
  hideHandles,
  hideIndicators,
  meta
}) {
  const { callbacks, shapeUtils, inputs: inputs2 } = useTLContext();
  const shapeTree = useShapeTree(page, pageState, shapeUtils, [inputs2.bounds.width, inputs2.bounds.height], meta, callbacks.onRenderCountChange);
  const { bounds, isLinked, isLocked, rotation } = useSelection(page, pageState, shapeUtils);
  const {
    selectedIds,
    hoveredId,
    camera: { zoom }
  } = pageState;
  let showCloneButtons = false;
  let shapeWithHandles = void 0;
  if (selectedIds.length === 1) {
    const id = selectedIds[0];
    const shape = page.shapes[id];
    const utils = shapeUtils[shape.type];
    showCloneButtons = utils.canClone;
    if (shape.handles !== void 0) {
      shapeWithHandles = shape;
    }
  }
  return /* @__PURE__ */ createElement20(Fragment4, null, bounds && /* @__PURE__ */ createElement20(BoundsBg, {
    bounds,
    rotation,
    isHidden: hideBounds
  }), shapeTree.map((node) => /* @__PURE__ */ createElement20(ShapeNode, __spreadValues({
    key: node.shape.id,
    utils: shapeUtils
  }, node))), !hideIndicators && selectedIds.map((id) => page.shapes[id]).filter(Boolean).map((shape) => /* @__PURE__ */ createElement20(ShapeIndicator, {
    key: "selected_" + shape.id,
    shape,
    meta,
    isSelected: true
  })), !hideIndicators && hoveredId && /* @__PURE__ */ createElement20(ShapeIndicator, {
    key: "hovered_" + hoveredId,
    shape: page.shapes[hoveredId],
    meta,
    isHovered: true
  }), bounds && /* @__PURE__ */ createElement20(Bounds, {
    zoom,
    bounds,
    viewportWidth: inputs2.bounds.width,
    isLocked,
    rotation,
    isHidden: hideBounds,
    isLinked,
    showCloneButtons
  }), !hideHandles && shapeWithHandles && /* @__PURE__ */ createElement20(Handles, {
    shape: shapeWithHandles
  }));
});

// src/components/users/users.tsx
import {
  Fragment as Fragment5,
  createElement as createElement22
} from "react";

// src/components/user/user.tsx
import {
  createElement as createElement21,
  useRef as useRef6
} from "react";
function User({ user }) {
  const rUser = useRef6(null);
  return /* @__PURE__ */ createElement21("div", {
    ref: rUser,
    className: "tl-absolute tl-user",
    style: {
      backgroundColor: user.color,
      transform: `translate(${user.point[0]}px, ${user.point[1]}px)`
    }
  });
}

// src/components/users/users.tsx
function Users({ userId, users }) {
  return /* @__PURE__ */ createElement22(Fragment5, null, Object.values(users).filter((user) => user && user.id !== userId).map((user) => /* @__PURE__ */ createElement22(User, {
    key: user.id,
    user
  })));
}

// src/hooks/useResizeObserver.ts
import {
  useCallback as useCallback7,
  useEffect as useEffect6,
  useReducer as useReducer2,
  useRef as useRef7
} from "react";
function useResizeObserver(ref) {
  const { inputs: inputs2, callbacks } = useTLContext();
  const rIsMounted = useRef7(false);
  const forceUpdate = useReducer2((x) => x + 1, 0)[1];
  const updateBounds = useCallback7(() => {
    var _a, _b;
    if (rIsMounted.current) {
      const rect = (_a = ref.current) == null ? void 0 : _a.getBoundingClientRect();
      if (rect) {
        inputs2.bounds = {
          minX: rect.left,
          maxX: rect.left + rect.width,
          minY: rect.top,
          maxY: rect.top + rect.height,
          width: rect.width,
          height: rect.height
        };
        (_b = callbacks.onBoundsChange) == null ? void 0 : _b.call(callbacks, inputs2.bounds);
        forceUpdate();
      }
    } else {
      rIsMounted.current = true;
    }
  }, [ref, forceUpdate, inputs2, callbacks.onBoundsChange]);
  useEffect6(() => {
    const debouncedupdateBounds = Utils.debounce(updateBounds, 100);
    window.addEventListener("scroll", debouncedupdateBounds);
    window.addEventListener("resize", debouncedupdateBounds);
    return () => {
      window.removeEventListener("scroll", debouncedupdateBounds);
      window.removeEventListener("resize", debouncedupdateBounds);
    };
  }, []);
  useEffect6(() => {
    const resizeObserver = new ResizeObserver((entries) => {
      if (inputs2.isPinching) {
        return;
      }
      if (entries[0].contentRect) {
        updateBounds();
      }
    });
    if (ref.current) {
      resizeObserver.observe(ref.current);
    }
    return () => {
      resizeObserver.disconnect();
    };
  }, [ref, inputs2]);
  useEffect6(() => {
    updateBounds();
  }, [ref]);
}

// src/inputs.ts
var DOUBLE_CLICK_DURATION = 250;
var Inputs = class {
  constructor() {
    this.keys = {};
    this.isPinching = false;
    this.bounds = {
      minX: 0,
      maxX: 640,
      minY: 0,
      maxY: 480,
      width: 640,
      height: 480
    };
    this.zoom = 1;
    this.pointerUpTime = 0;
    this.panStart = (e2) => {
      var _a, _b;
      const { shiftKey, ctrlKey, metaKey, altKey } = e2;
      const info = {
        target: "wheel",
        pointerId: ((_a = this.pointer) == null ? void 0 : _a.pointerId) || 0,
        origin: ((_b = this.pointer) == null ? void 0 : _b.origin) || [0, 0],
        delta: [0, 0],
        pressure: 0.5,
        point: Inputs.getPoint(e2, this.bounds),
        shiftKey,
        ctrlKey,
        metaKey,
        altKey,
        spaceKey: this.keys[" "]
      };
      this.pointer = info;
      return info;
    };
    this.pan = (delta, e2) => {
      if (!this.pointer || this.pointer.target !== "wheel") {
        return this.panStart(e2);
      }
      const { shiftKey, ctrlKey, metaKey, altKey } = e2;
      const prev = this.pointer;
      const point = Inputs.getPoint(e2, this.bounds);
      const info = __spreadProps(__spreadValues({}, prev), {
        target: "wheel",
        delta,
        point,
        shiftKey,
        ctrlKey,
        metaKey,
        altKey,
        spaceKey: this.keys[" "]
      });
      this.pointer = info;
      return info;
    };
    this.keydown = (e2) => {
      var _a, _b;
      const { shiftKey, ctrlKey, metaKey, altKey } = e2;
      this.keys[e2.key] = true;
      return {
        point: ((_a = this.pointer) == null ? void 0 : _a.point) || [0, 0],
        origin: ((_b = this.pointer) == null ? void 0 : _b.origin) || [0, 0],
        key: e2.key,
        keys: Object.keys(this.keys),
        shiftKey,
        ctrlKey,
        metaKey: Utils.isDarwin() ? metaKey : ctrlKey,
        altKey
      };
    };
    this.keyup = (e2) => {
      var _a, _b;
      const { shiftKey, ctrlKey, metaKey, altKey } = e2;
      delete this.keys[e2.key];
      return {
        point: ((_a = this.pointer) == null ? void 0 : _a.point) || [0, 0],
        origin: ((_b = this.pointer) == null ? void 0 : _b.origin) || [0, 0],
        key: e2.key,
        keys: Object.keys(this.keys),
        shiftKey,
        ctrlKey,
        metaKey: Utils.isDarwin() ? metaKey : ctrlKey,
        altKey
      };
    };
  }
  pointerIsValid(e2) {
    if ("pointerId" in e2) {
      if (this.activePointer && this.activePointer !== e2.pointerId)
        return false;
    }
    if ("touches" in e2) {
      const touch = e2.changedTouches[0];
      if (this.activePointer && this.activePointer !== touch.identifier)
        return false;
    }
    return true;
  }
  touchStart(e2, target) {
    const { shiftKey, ctrlKey, metaKey, altKey } = e2;
    const touch = e2.changedTouches[0];
    this.activePointer = touch.identifier;
    const info = {
      target,
      pointerId: touch.identifier,
      origin: Inputs.getPoint(touch, this.bounds),
      delta: [0, 0],
      point: Inputs.getPoint(touch, this.bounds),
      pressure: Inputs.getPressure(touch),
      shiftKey,
      ctrlKey,
      metaKey: Utils.isDarwin() ? metaKey : ctrlKey,
      altKey,
      spaceKey: this.keys[" "]
    };
    this.pointer = info;
    return info;
  }
  touchEnd(e2, target) {
    const { shiftKey, ctrlKey, metaKey, altKey } = e2;
    const touch = e2.changedTouches[0];
    const info = {
      target,
      pointerId: touch.identifier,
      origin: Inputs.getPoint(touch, this.bounds),
      delta: [0, 0],
      point: Inputs.getPoint(touch, this.bounds),
      pressure: Inputs.getPressure(touch),
      shiftKey,
      ctrlKey,
      metaKey: Utils.isDarwin() ? metaKey : ctrlKey,
      altKey,
      spaceKey: this.keys[" "]
    };
    this.pointer = info;
    this.activePointer = void 0;
    return info;
  }
  touchMove(e2, target) {
    const { shiftKey, ctrlKey, metaKey, altKey } = e2;
    const touch = e2.changedTouches[0];
    const prev = this.pointer;
    const point = Inputs.getPoint(touch, this.bounds);
    const delta = (prev == null ? void 0 : prev.point) ? e.sub(point, prev.point) : [0, 0];
    const info = __spreadProps(__spreadValues({
      origin: point
    }, prev), {
      target,
      pointerId: touch.identifier,
      point,
      delta,
      pressure: Inputs.getPressure(touch),
      shiftKey,
      ctrlKey,
      metaKey: Utils.isDarwin() ? metaKey : ctrlKey,
      altKey,
      spaceKey: this.keys[" "]
    });
    this.pointer = info;
    return info;
  }
  pointerDown(e2, target) {
    const { shiftKey, ctrlKey, metaKey, altKey } = e2;
    const point = Inputs.getPoint(e2, this.bounds);
    this.activePointer = e2.pointerId;
    const info = {
      target,
      pointerId: e2.pointerId,
      origin: point,
      point,
      delta: [0, 0],
      pressure: Inputs.getPressure(e2),
      shiftKey,
      ctrlKey,
      metaKey: Utils.isDarwin() ? metaKey : ctrlKey,
      altKey,
      spaceKey: this.keys[" "]
    };
    this.pointer = info;
    return info;
  }
  pointerEnter(e2, target) {
    const { shiftKey, ctrlKey, metaKey, altKey } = e2;
    const point = Inputs.getPoint(e2, this.bounds);
    const info = {
      target,
      pointerId: e2.pointerId,
      origin: point,
      delta: [0, 0],
      point,
      pressure: Inputs.getPressure(e2),
      shiftKey,
      ctrlKey,
      metaKey: Utils.isDarwin() ? metaKey : ctrlKey,
      altKey,
      spaceKey: this.keys[" "]
    };
    this.pointer = info;
    return info;
  }
  pointerMove(e2, target) {
    const { shiftKey, ctrlKey, metaKey, altKey } = e2;
    const prev = this.pointer;
    const point = Inputs.getPoint(e2, this.bounds);
    const delta = (prev == null ? void 0 : prev.point) ? e.sub(point, prev.point) : [0, 0];
    const info = __spreadProps(__spreadValues({
      origin: point
    }, prev), {
      target,
      pointerId: e2.pointerId,
      point,
      delta,
      pressure: Inputs.getPressure(e2),
      shiftKey,
      ctrlKey,
      metaKey: Utils.isDarwin() ? metaKey : ctrlKey,
      altKey,
      spaceKey: this.keys[" "]
    });
    this.pointer = info;
    return info;
  }
  pointerUp(e2, target) {
    const { shiftKey, ctrlKey, metaKey, altKey } = e2;
    const prev = this.pointer;
    const point = Inputs.getPoint(e2, this.bounds);
    const delta = (prev == null ? void 0 : prev.point) ? e.sub(point, prev.point) : [0, 0];
    this.activePointer = void 0;
    const info = __spreadProps(__spreadValues({
      origin: point
    }, prev), {
      target,
      pointerId: e2.pointerId,
      point,
      delta,
      pressure: Inputs.getPressure(e2),
      shiftKey,
      ctrlKey,
      metaKey: Utils.isDarwin() ? metaKey : ctrlKey,
      altKey,
      spaceKey: this.keys[" "]
    });
    this.pointer = info;
    this.pointerUpTime = Date.now();
    return info;
  }
  isDoubleClick() {
    if (!this.pointer)
      return false;
    const { origin, point } = this.pointer;
    return Date.now() - this.pointerUpTime < DOUBLE_CLICK_DURATION && e.dist(origin, point) < 4;
  }
  clear() {
    this.pointer = void 0;
  }
  resetDoubleClick() {
    this.pointerUpTime = 0;
  }
  pinch(point, origin) {
    const { shiftKey, ctrlKey, metaKey, altKey } = this.keys;
    const delta = e.sub(origin, point);
    const info = {
      pointerId: 0,
      target: "pinch",
      origin,
      delta,
      point: e.sub(e.round(point), [this.bounds.minX, this.bounds.minY]),
      pressure: 0.5,
      shiftKey,
      ctrlKey,
      metaKey: Utils.isDarwin() ? metaKey : ctrlKey,
      altKey,
      spaceKey: this.keys[" "]
    };
    this.pointer = info;
    return info;
  }
  reset() {
    this.pointerUpTime = 0;
    this.pointer = void 0;
    this.keyboard = void 0;
    this.activePointer = void 0;
    this.keys = {};
  }
  static getPoint(e2, bounds) {
    return [+e2.clientX.toFixed(2) - bounds.minX, +e2.clientY.toFixed(2) - bounds.minY];
  }
  static getPressure(e2) {
    return "pressure" in e2 ? +e2.pressure.toFixed(2) || 0.5 : 0.5;
  }
  static commandKey() {
    return Utils.isDarwin() ? "\u2318" : "Ctrl";
  }
};
var inputs = new Inputs();

// src/components/users-indicators/users-indicators.tsx
import {
  Fragment as Fragment6,
  createElement as createElement23
} from "react";
function UsersIndicators({
  userId,
  users,
  meta,
  page
}) {
  const { shapeUtils } = useTLContext();
  return /* @__PURE__ */ createElement23(Fragment6, null, Object.values(users).filter(Boolean).filter((user) => user.id !== userId && user.selectedIds.length > 0).map((user) => {
    const shapes = user.selectedIds.map((id) => page.shapes[id]).filter(Boolean);
    if (shapes.length === 0)
      return null;
    const bounds = utils_default.getCommonBounds(shapes.map((shape) => shapeUtils[shape.type].getBounds(shape)));
    return /* @__PURE__ */ createElement23(Fragment6, {
      key: user.id + "_shapes"
    }, /* @__PURE__ */ createElement23("div", {
      className: "tl-absolute tl-user-indicator-bounds",
      style: {
        backgroundColor: user.color + "0d",
        borderColor: user.color + "78",
        transform: `translate(${bounds.minX}px, ${bounds.minY}px)`,
        width: bounds.width,
        height: bounds.height,
        pointerEvents: "none"
      }
    }), shapes.map((shape) => /* @__PURE__ */ createElement23(ShapeIndicator, {
      key: `${user.id}_${shape.id}_indicator`,
      shape,
      color: user.color,
      meta,
      isHovered: true
    })));
  }));
}

// src/components/snap-lines/snap-lines.tsx
import {
  Fragment as Fragment7,
  createElement as createElement24
} from "react";
function SnapLines({ snapLines }) {
  return /* @__PURE__ */ createElement24(Fragment7, null, snapLines.map((snapLine, i) => /* @__PURE__ */ createElement24(SnapLine, {
    key: i,
    snapLine
  })));
}
function SnapLine({ snapLine }) {
  const bounds = utils_default.getBoundsFromPoints(snapLine);
  return /* @__PURE__ */ createElement24(Fragment7, null, /* @__PURE__ */ createElement24("line", {
    className: "tl-snap-line",
    x1: bounds.minX,
    y1: bounds.minY,
    x2: bounds.maxX,
    y2: bounds.maxY
  }), snapLine.map(([x, y], i) => /* @__PURE__ */ createElement24("use", {
    key: i,
    href: "#tl-snap-point",
    x,
    y
  })));
}

// src/components/overlay/overlay.tsx
import {
  createElement as createElement25
} from "react";
function Overlay({
  camera,
  children
}) {
  const l = 2.5 / camera.zoom;
  return /* @__PURE__ */ createElement25("svg", {
    className: "tl-overlay"
  }, /* @__PURE__ */ createElement25("defs", null, /* @__PURE__ */ createElement25("g", {
    id: "tl-snap-point"
  }, /* @__PURE__ */ createElement25("path", {
    className: "tl-snap-point",
    d: `M ${-l},${-l} L ${l},${l} M ${-l},${l} L ${l},${-l}`
  }))), /* @__PURE__ */ createElement25("g", {
    transform: `scale(${camera.zoom}) translate(${camera.point})`
  }, children));
}

// src/components/canvas/canvas.tsx
function resetError() {
  void 0;
}
function Canvas({
  id,
  page,
  pageState,
  snapLines,
  users,
  userId,
  meta,
  externalContainerRef,
  hideHandles = false,
  hideBounds = false,
  hideIndicators = false
}) {
  const rCanvas = useRef8(null);
  const rContainer = useRef8(null);
  const rLayer = useRef8(null);
  inputs.zoom = pageState.camera.zoom;
  useResizeObserver(rCanvas);
  useZoomEvents(pageState.camera.zoom, externalContainerRef || rCanvas);
  useSafariFocusOutFix();
  usePreventNavigation(rCanvas, inputs.bounds.width);
  useCameraCss(rLayer, rContainer, pageState);
  useKeyEvents();
  const events = useCanvasEvents();
  return /* @__PURE__ */ createElement26("div", {
    id,
    className: "tl-container",
    ref: rContainer
  }, /* @__PURE__ */ createElement26("div", __spreadValues({
    id: "canvas",
    className: "tl-absolute tl-canvas",
    ref: rCanvas
  }, events), /* @__PURE__ */ createElement26(ErrorBoundary, {
    FallbackComponent: ErrorFallback,
    onReset: resetError
  }, /* @__PURE__ */ createElement26("div", {
    ref: rLayer,
    className: "tl-absolute tl-layer"
  }, /* @__PURE__ */ createElement26(Page, {
    page,
    pageState,
    hideBounds,
    hideIndicators,
    hideHandles,
    meta
  }), users && userId && /* @__PURE__ */ createElement26(UsersIndicators, {
    userId,
    users,
    page,
    meta
  }), pageState.brush && /* @__PURE__ */ createElement26(Brush, {
    brush: pageState.brush
  }), users && /* @__PURE__ */ createElement26(Users, {
    userId,
    users
  }))), /* @__PURE__ */ createElement26(Overlay, {
    camera: pageState.camera
  }, snapLines && /* @__PURE__ */ createElement26(SnapLines, {
    snapLines
  }))));
}

// src/components/renderer/renderer.tsx
function Renderer(_a) {
  var _b = _a, {
    id = "tl",
    shapeUtils,
    page,
    pageState,
    users,
    userId,
    theme,
    meta,
    snapLines,
    containerRef,
    hideHandles = false,
    hideIndicators = false,
    hideBounds = false,
    onMount
  } = _b, rest = __objRest(_b, [
    "id",
    "shapeUtils",
    "page",
    "pageState",
    "users",
    "userId",
    "theme",
    "meta",
    "snapLines",
    "containerRef",
    "hideHandles",
    "hideIndicators",
    "hideBounds",
    "onMount"
  ]);
  useTLTheme(theme, "#" + id);
  const rSelectionBounds = useRef9(null);
  const rPageState = useRef9(pageState);
  useEffect7(() => {
    rPageState.current = pageState;
  }, [pageState]);
  const [context] = useState(() => ({
    callbacks: rest,
    shapeUtils,
    rSelectionBounds,
    rPageState,
    inputs: new Inputs()
  }));
  useEffect7(() => {
    onMount == null ? void 0 : onMount(context.inputs);
  }, [context]);
  return /* @__PURE__ */ createElement27(TLContext.Provider, {
    value: context
  }, /* @__PURE__ */ createElement27(Canvas, {
    id,
    page,
    pageState,
    snapLines,
    users,
    userId,
    hideBounds,
    hideIndicators,
    hideHandles,
    externalContainerRef: containerRef,
    meta
  }));
}

// src/components/html-container/html-container.tsx
import {
  createElement as createElement28,
  forwardRef as forwardRef2,
  memo as memo18
} from "react";
var HTMLContainer = memo18(forwardRef2((_a, ref) => {
  var _b = _a, { children } = _b, rest = __objRest(_b, ["children"]);
  return /* @__PURE__ */ createElement28("div", __spreadValues({
    ref,
    className: "tl-positioned-div"
  }, rest), children);
}));

// src/shapes/createShape.tsx
import {
  createRef,
  forwardRef as forwardRef3
} from "react";

// ../intersect/dist/esm/index.js
var b = class {
  static clamp(e2, n, t) {
    return Math.max(n, typeof t != "undefined" ? Math.min(e2, t) : e2);
  }
  static clampV(e2, n, t) {
    return e2.map((r) => t ? b.clamp(r, n, t) : b.clamp(r, n));
  }
  static cross(e2, n, t) {
    return (n[0] - e2[0]) * (t[1] - e2[1]) - (t[0] - e2[0]) * (n[1] - e2[1]);
  }
};
var o = b;
o.neg = (e2) => [-e2[0], -e2[1]], o.add = (e2, n) => [e2[0] + n[0], e2[1] + n[1]], o.addScalar = (e2, n) => [e2[0] + n, e2[1] + n], o.sub = (e2, n) => [e2[0] - n[0], e2[1] - n[1]], o.subScalar = (e2, n) => [e2[0] - n, e2[1] - n], o.vec = (e2, n) => [n[0] - e2[0], n[1] - e2[1]], o.mul = (e2, n) => [e2[0] * n, e2[1] * n], o.mulV = (e2, n) => [e2[0] * n[0], e2[1] * n[1]], o.div = (e2, n) => [e2[0] / n, e2[1] / n], o.divV = (e2, n) => [e2[0] / n[0], e2[1] / n[1]], o.per = (e2) => [e2[1], -e2[0]], o.dpr = (e2, n) => e2[0] * n[0] + e2[1] * n[1], o.cpr = (e2, n) => e2[0] * n[1] - n[0] * e2[1], o.len2 = (e2) => e2[0] * e2[0] + e2[1] * e2[1], o.len = (e2) => Math.hypot(e2[0], e2[1]), o.pry = (e2, n) => b.dpr(e2, n) / b.len(n), o.uni = (e2) => b.div(e2, b.len(e2)), o.normalize = (e2) => b.uni(e2), o.tangent = (e2, n) => b.normalize(b.sub(e2, n)), o.dist2 = (e2, n) => b.len2(b.sub(e2, n)), o.dist = (e2, n) => Math.hypot(e2[1] - n[1], e2[0] - n[0]), o.fastDist = (e2, n) => {
  let t = [n[0] - e2[0], n[1] - e2[1]], r = [Math.abs(t[0]), Math.abs(t[1])], i = 1 / Math.max(r[0], r[1]);
  return i = i * (1.29289 - (r[0] + r[1]) * i * 0.29289), [t[0] * i, t[1] * i];
}, o.ang = (e2, n) => Math.atan2(b.cpr(e2, n), b.dpr(e2, n)), o.angle = (e2, n) => Math.atan2(n[1] - e2[1], n[0] - e2[0]), o.med = (e2, n) => b.mul(b.add(e2, n), 0.5), o.rot = (e2, n) => [e2[0] * Math.cos(n) - e2[1] * Math.sin(n), e2[0] * Math.sin(n) + e2[1] * Math.cos(n)], o.rotWith = (e2, n, t) => {
  if (t === 0)
    return e2;
  let r = Math.sin(t), i = Math.cos(t), u2 = e2[0] - n[0], s = e2[1] - n[1], c = u2 * i - s * r, m = u2 * r + s * i;
  return [c + n[0], m + n[1]];
}, o.isEqual = (e2, n) => e2[0] === n[0] && e2[1] === n[1], o.lrp = (e2, n, t) => b.add(e2, b.mul(b.sub(n, e2), t)), o.int = (e2, n, t, r, i = 1) => {
  let u2 = (b.clamp(t, r) - t) / (r - t);
  return b.add(b.mul(e2, 1 - u2), b.mul(n, i));
}, o.ang3 = (e2, n, t) => {
  let r = b.vec(n, e2), i = b.vec(n, t);
  return b.ang(r, i);
}, o.abs = (e2) => [Math.abs(e2[0]), Math.abs(e2[1])], o.rescale = (e2, n) => {
  let t = b.len(e2);
  return [n * e2[0] / t, n * e2[1] / t];
}, o.isLeft = (e2, n, t) => (n[0] - e2[0]) * (t[1] - e2[1]) - (t[0] - e2[0]) * (n[1] - e2[1]), o.clockwise = (e2, n, t) => b.isLeft(e2, n, t) > 0, o.round = (e2, n = 2) => e2.map((t) => +t.toFixed(n)), o.nearestPointOnLineThroughPoint = (e2, n, t) => b.add(e2, b.mul(n, b.pry(b.sub(t, e2), n))), o.distanceToLineThroughPoint = (e2, n, t) => b.dist(t, b.nearestPointOnLineThroughPoint(e2, n, t)), o.nearestPointOnLineSegment = (e2, n, t, r = true) => {
  let i = b.sub(n, e2), u2 = b.len(i), s = b.div(i, u2), c = b.add(e2, b.mul(s, b.pry(b.sub(t, e2), s)));
  if (r) {
    let m = b.dist(e2, c), d = b.dist(n, c);
    if (d < m && m > u2)
      return n;
    if (m < d && d > u2)
      return e2;
  }
  return c;
}, o.distanceToLineSegment = (e2, n, t, r = true) => b.dist(t, b.nearestPointOnLineSegment(e2, n, t, r)), o.nudge = (e2, n, t) => b.add(e2, b.mul(b.uni(b.vec(e2, n)), t)), o.nudgeAtAngle = (e2, n, t) => [Math.cos(n) * t + e2[0], Math.sin(n) * t + e2[1]], o.toPrecision = (e2, n = 4) => [+e2[0].toPrecision(n), +e2[1].toPrecision(n)], o.pointsBetween = (e2, n, t = 6) => Array.from(Array(t)).map((r, i) => {
  let u2 = i / (t - 1), s = Math.min(1, 0.5 + Math.abs(0.5 - u2));
  return [...b.lrp(e2, n, u2), s];
});
function h(e2, ...n) {
  return { didIntersect: n.length > 0, message: e2, points: n };
}
function p(e2, n, t = 0) {
  let r = [e2[0] + n[0] / 2, e2[1] + n[1] / 2], i = o.rotWith(e2, r, t), u2 = o.rotWith(o.add(e2, [n[0], 0]), r, t), s = o.rotWith(o.add(e2, n), r, t), c = o.rotWith(o.add(e2, [0, n[1]]), r, t);
  return [["top", [i, u2]], ["right", [u2, s]], ["bottom", [s, c]], ["left", [c, i]]];
}
function S(e2, n, t, r) {
  let [i, u2] = e2, [s, c] = n, [m, d] = t, [l, f] = r;
  if (c / s != (f - d) / (l - m)) {
    let L = s * (f - d) - c * (l - m);
    if (L !== 0) {
      let a = ((u2 - d) * (l - m) - (i - m) * (f - d)) / L, I = ((u2 - d) * s - (i - m) * c) / L;
      if (a >= 0 && I >= 0 && I <= 1)
        return h("intersection", [i + a * s, u2 + a * c]);
    }
  }
  return h("no intersection");
}
function w(e2, n, t, r, i = 0) {
  return j(t, r, i, e2, n);
}
function re(e2, n, t, r = 0) {
  let { minX: i, minY: u2, width: s, height: c } = t;
  return w(e2, n, [i, u2], [s, c], r);
}
function P(e2, n, t, r) {
  let i = o.sub(e2, t), u2 = o.sub(r, t), s = o.sub(n, e2), c = u2[0] * i[1] - u2[1] * i[0], m = s[0] * i[1] - s[1] * i[0], d = u2[1] * s[0] - u2[0] * s[1];
  if (c === 0 || m === 0)
    return h("coincident");
  if (d === 0)
    return h("parallel");
  if (d !== 0) {
    let l = c / d, f = m / d;
    if (0 <= l && l <= 1 && 0 <= f && f <= 1)
      return h("intersection", o.add(e2, o.mul(s, l)));
  }
  return h("no intersection");
}
function A(e2, n, t) {
  let r = [];
  for (let i = 1; i < t.length + 1; i++) {
    let u2 = P(e2, n, t[i - 1], t[i % t.length]);
    u2 && r.push(u2);
  }
  return r;
}
function j(e2, n, t, r, i) {
  return p(e2, n, t).reduce((s, [c, [m, d]]) => {
    let l = S(r, i, m, d);
    return l && s.push(h(c, ...l.points)), s;
  }, []).filter((s) => s.didIntersect);
}
function E(e2, n, t) {
  return p(e2, n).reduce((i, [u2, [s, c]]) => {
    let m = A(s, c, t);
    return m.length > 0 && i.push(h(u2, ...m.flatMap((d) => d.points))), i;
  }, []).filter((i) => i.didIntersect);
}
function Z(e2, n) {
  return E([n.minX, n.minY], [n.width, n.height], e2);
}

// src/shapes/createShape.tsx
var ShapeUtil = function(fn) {
  const defaults = {
    refMap: new Map(),
    boundsCache: new WeakMap(),
    canEdit: false,
    canBind: false,
    showBounds: true,
    isStateful: false,
    canClone: false,
    isAspectRatioLocked: false,
    create: (props) => {
      this.refMap.set(props.id, createRef());
      const defaults2 = this.defaultProps;
      return __spreadValues(__spreadValues({}, defaults2), props);
    },
    getRef: (shape) => {
      if (!this.refMap.has(shape.id)) {
        this.refMap.set(shape.id, createRef());
      }
      return this.refMap.get(shape.id);
    },
    mutate: (shape, props) => {
      return __spreadValues(__spreadValues({}, shape), props);
    },
    transform: (shape, bounds) => {
      return __spreadProps(__spreadValues({}, shape), { point: [bounds.minX, bounds.minY] });
    },
    transformSingle: (shape, bounds, info) => {
      return this.transform(shape, bounds, info);
    },
    shouldRender: () => {
      return true;
    },
    getRotatedBounds: (shape) => {
      return utils_default.getBoundsFromPoints(utils_default.getRotatedCorners(this.getBounds(shape), shape.rotation));
    },
    getCenter: (shape) => {
      return utils_default.getBoundsCenter(this.getBounds(shape));
    },
    hitTest: (shape, point) => {
      return utils_default.pointInBounds(point, this.getBounds(shape));
    },
    hitTestBounds: (shape, bounds) => {
      const { minX, minY, maxX, maxY, width, height } = this.getBounds(shape);
      const center = [minX + width / 2, minY + height / 2];
      const corners = [
        [minX, minY],
        [maxX, minY],
        [maxX, maxY],
        [minX, maxY]
      ].map((point) => e.rotWith(point, center, shape.rotation || 0));
      return corners.every((point) => !(point[0] < bounds.minX || point[0] > bounds.maxX || point[1] < bounds.minY || point[1] > bounds.maxY)) || Z(corners, bounds).length > 0;
    },
    getBindingPoint: (shape, fromShape, point, origin, direction, padding, bindAnywhere) => {
      let bindingPoint;
      let distance;
      const bounds = this.getBounds(shape);
      const expandedBounds = utils_default.expandBounds(bounds, padding);
      if (!utils_default.pointInBounds(point, expandedBounds))
        return;
      if (bindAnywhere) {
        if (e.dist(point, this.getCenter(shape)) < 12) {
          bindingPoint = [0.5, 0.5];
        } else {
          bindingPoint = e.divV(e.sub(point, [expandedBounds.minX, expandedBounds.minY]), [
            expandedBounds.width,
            expandedBounds.height
          ]);
        }
        distance = 0;
      } else {
        const intersection = re(origin, direction, expandedBounds).filter((int) => int.didIntersect).map((int) => int.points[0]).sort((a, b2) => e.dist(b2, origin) - e.dist(a, origin))[0];
        const anchor = e.med(point, intersection);
        if (e.distanceToLineSegment(point, anchor, this.getCenter(shape)) < 12) {
          bindingPoint = [0.5, 0.5];
        } else {
          bindingPoint = e.divV(e.sub(anchor, [expandedBounds.minX, expandedBounds.minY]), [
            expandedBounds.width,
            expandedBounds.height
          ]);
        }
        if (utils_default.pointInBounds(point, bounds)) {
          distance = 16;
        } else {
          distance = Math.max(16, utils_default.getBoundsSides(bounds).map((side) => e.distanceToLineSegment(side[1][0], side[1][1], point)).sort((a, b2) => a - b2)[0]);
        }
      }
      return {
        point: e.clampV(bindingPoint, 0, 1),
        distance
      };
    },
    onDoubleClickBoundsHandle() {
      return;
    },
    onDoubleClickHandle() {
      return;
    },
    onHandleChange() {
      return;
    },
    onRightPointHandle() {
      return;
    },
    onSessionComplete() {
      return;
    },
    onStyleChange() {
      return;
    },
    onBindingChange() {
      return;
    },
    onChildrenChange() {
      return;
    },
    updateChildren() {
      return;
    }
  };
  Object.assign(this, defaults);
  Object.assign(this, fn.call(this));
  Object.assign(this, fn.call(this));
  for (const entry of Object.entries(this)) {
    if (entry[1] instanceof Function) {
      this[entry[0]] = this[entry[0]].bind(this);
    }
  }
  this._Component = forwardRef3(this.Component);
  return this;
};
export {
  HTMLContainer,
  Inputs,
  Renderer,
  SVGContainer,
  ShapeUtil,
  Svg,
  TLBoundsCorner,
  TLBoundsEdge,
  Utils,
  inputs
};
/**
 * String.prototype.replaceAll() polyfill
 * https://gomakethings.com/how-to-replace-a-section-of-a-string-with-another-one-with-vanilla-js/
 * @author Chris Ferdinandi
 * @license MIT
 */
//# sourceMappingURL=index.js.map
